
//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <iterator>

// module include
#include "cutterbindings_python.h"

// main header
#include "configuration_wrapper.h"

// inner classes

#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}

// Native ---------------------------------------------------------

void ConfigurationWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

void ConfigurationWrapper::childEvent(QChildEvent * event)
{
    if (m_PyMethodCache[0]) {
        return this->::QObject::childEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "childEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[0] = true;
        return this->::QObject::childEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QCHILDEVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
}

void ConfigurationWrapper::connectNotify(const QMetaMethod & signal)
{
    if (m_PyMethodCache[1]) {
        return this->::QObject::connectNotify(signal);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "connectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[1] = true;
        return this->::QObject::connectNotify(signal);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QMETAMETHOD_IDX]), &signal)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

void ConfigurationWrapper::customEvent(QEvent * event)
{
    if (m_PyMethodCache[2]) {
        return this->::QObject::customEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "customEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[2] = true;
        return this->::QObject::customEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QEVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
}

void ConfigurationWrapper::disconnectNotify(const QMetaMethod & signal)
{
    if (m_PyMethodCache[3]) {
        return this->::QObject::disconnectNotify(signal);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "disconnectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[3] = true;
        return this->::QObject::disconnectNotify(signal);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QMETAMETHOD_IDX]), &signal)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

bool ConfigurationWrapper::event(QEvent * event)
{
    if (m_PyMethodCache[4])
        return this->::QObject::event(event);
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "event";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[4] = true;
        return this->::QObject::event(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QEVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return false;
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "Configuration.event", "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
    return cppResult;
}

bool ConfigurationWrapper::eventFilter(QObject * watched, QEvent * event)
{
    if (m_PyMethodCache[5])
        return this->::QObject::eventFilter(watched, event);
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "eventFilter";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[5] = true;
        return this->::QObject::eventFilter(watched, event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(NN)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QOBJECT_IDX]), watched),
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QEVENT_IDX]), event)
    ));
    bool invalidateArg2 = PyTuple_GET_ITEM(pyArgs, 1)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return false;
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "Configuration.eventFilter", "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    if (invalidateArg2)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 1));
    return cppResult;
}

void ConfigurationWrapper::timerEvent(QTimerEvent * event)
{
    if (m_PyMethodCache[7]) {
        return this->::QObject::timerEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "timerEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[7] = true;
        return this->::QObject::timerEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QTIMEREVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
}

const QMetaObject *ConfigurationWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return Configuration::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int ConfigurationWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = Configuration::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *ConfigurationWrapper::qt_metacast(const char *_clname)
{
        if (!_clname) return {};
        SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
        if (pySelf && PySide::inherits(Py_TYPE(pySelf), _clname))
                return static_cast<void *>(const_cast< ConfigurationWrapper *>(this));
        return Configuration::qt_metacast(_clname);
}

ConfigurationWrapper::~ConfigurationWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_ConfigurationFunc_addRecentProject(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.addRecentProject";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::addRecentProject(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // addRecentProject(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_addRecentProject_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // addRecentProject(QString)
            cppSelf->addRecentProject(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_addRecentProject_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_adjustColorThemeDarkness(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.adjustColorThemeDarkness";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // adjustColorThemeDarkness()
            cppSelf->adjustColorThemeDarkness();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_ConfigurationFunc_colorThemeDarkness(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.colorThemeDarkness";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::colorThemeDarkness(QString)const
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // colorThemeDarkness(QString)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_colorThemeDarkness_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // colorThemeDarkness(QString)const
            int cppResult = const_cast<const ::Configuration *>(cppSelf)->colorThemeDarkness(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_colorThemeDarkness_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_createSyntaxHighlighter(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.createSyntaxHighlighter";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::createSyntaxHighlighter(QTextDocument*)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppPointerConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QTEXTDOCUMENT_IDX]), (pyArg)))) {
        overloadId = 0; // createSyntaxHighlighter(QTextDocument*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_createSyntaxHighlighter_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QTextDocument *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // createSyntaxHighlighter(QTextDocument*)
            QSyntaxHighlighter * cppResult = cppSelf->createSyntaxHighlighter(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QSYNTAXHIGHLIGHTER_IDX]), cppResult);
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_createSyntaxHighlighter_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_enableDecompilerAnnotationHighlighter(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.enableDecompilerAnnotationHighlighter";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::enableDecompilerAnnotationHighlighter(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // enableDecompilerAnnotationHighlighter(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_enableDecompilerAnnotationHighlighter_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // enableDecompilerAnnotationHighlighter(bool)
            cppSelf->enableDecompilerAnnotationHighlighter(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_enableDecompilerAnnotationHighlighter_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_getAutoUpdateEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getAutoUpdateEnabled";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getAutoUpdateEnabled()const
            bool cppResult = const_cast<const ::Configuration *>(cppSelf)->getAutoUpdateEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getAvailableTranslations(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getAvailableTranslations";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getAvailableTranslations()
            QStringList cppResult = cppSelf->getAvailableTranslations();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getBaseFont(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getBaseFont";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getBaseFont()const
            const QFont cppResult = const_cast<const ::Configuration *>(cppSelf)->getBaseFont();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QFONT_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getBitmapExportScaleFactor(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getBitmapExportScaleFactor";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getBitmapExportScaleFactor()
            double cppResult = cppSelf->getBitmapExportScaleFactor();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<double>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getBitmapTransparentState(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getBitmapTransparentState";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getBitmapTransparentState()
            bool cppResult = cppSelf->getBitmapTransparentState();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getColor(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getColor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::getColor(QString)const
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getColor(QString)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_getColor_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getColor(QString)const
            const QColor cppResult = const_cast<const ::Configuration *>(cppSelf)->getColor(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QCOLOR_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_getColor_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_getColorTheme(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getColorTheme";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getColorTheme()const
            QString cppResult = const_cast<const ::Configuration *>(cppSelf)->getColorTheme();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getConfigBool(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getConfigBool";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::getConfigBool(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigBool(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_getConfigBool_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigBool(QString)
            bool cppResult = cppSelf->getConfigBool(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_getConfigBool_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_getConfigInt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getConfigInt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::getConfigInt(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigInt(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_getConfigInt_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigInt(QString)
            int cppResult = cppSelf->getConfigInt(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_getConfigInt_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_getConfigString(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getConfigString";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::getConfigString(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigString(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_getConfigString_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigString(QString)
            QString cppResult = cppSelf->getConfigString(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_getConfigString_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_getConfigVar(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getConfigVar";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::getConfigVar(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigVar(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_getConfigVar_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigVar(QString)
            QVariant cppResult = cppSelf->getConfigVar(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QVARIANT_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_getConfigVar_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_getCurrLocale(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getCurrLocale";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getCurrLocale()const
            QLocale cppResult = const_cast<const ::Configuration *>(cppSelf)->getCurrLocale();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QLOCALE_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getDecompilerAutoRefreshEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getDecompilerAutoRefreshEnabled";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getDecompilerAutoRefreshEnabled()
            bool cppResult = cppSelf->getDecompilerAutoRefreshEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getFont(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getFont";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getFont()const
            const QFont cppResult = const_cast<const ::Configuration *>(cppSelf)->getFont();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QFONT_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getFunctionsWidgetLayout(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getFunctionsWidgetLayout";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getFunctionsWidgetLayout()
            QString cppResult = cppSelf->getFunctionsWidgetLayout();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getGraphBlockEntryOffset(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getGraphBlockEntryOffset";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getGraphBlockEntryOffset()
            bool cppResult = cppSelf->getGraphBlockEntryOffset();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getGraphBlockMaxChars(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getGraphBlockMaxChars";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getGraphBlockMaxChars()const
            int cppResult = const_cast<const ::Configuration *>(cppSelf)->getGraphBlockMaxChars();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getGraphBlockSpacing(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getGraphBlockSpacing";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getGraphBlockSpacing()
            QPoint cppResult = cppSelf->getGraphBlockSpacing();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QPOINT_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getGraphEdgeSpacing(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getGraphEdgeSpacing";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getGraphEdgeSpacing()
            QPoint cppResult = cppSelf->getGraphEdgeSpacing();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QPOINT_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getGraphMinFontSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getGraphMinFontSize";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getGraphMinFontSize()const
            int cppResult = const_cast<const ::Configuration *>(cppSelf)->getGraphMinFontSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getGraphPreview(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getGraphPreview";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getGraphPreview()
            bool cppResult = cppSelf->getGraphPreview();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getInterfaceTheme(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getInterfaceTheme";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getInterfaceTheme()
            int cppResult = cppSelf->getInterfaceTheme();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getLogoFile(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getLogoFile";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getLogoFile()
            QString cppResult = cppSelf->getLogoFile();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getNewFileLastClicked(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getNewFileLastClicked";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getNewFileLastClicked()
            int cppResult = cppSelf->getNewFileLastClicked();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getOutputRedirectionEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getOutputRedirectionEnabled";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getOutputRedirectionEnabled()const
            bool cppResult = const_cast<const ::Configuration *>(cppSelf)->getOutputRedirectionEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getPreviewValue(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getPreviewValue";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getPreviewValue()const
            bool cppResult = const_cast<const ::Configuration *>(cppSelf)->getPreviewValue();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getRecentFiles(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getRecentFiles";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getRecentFiles()const
            QStringList cppResult = const_cast<const ::Configuration *>(cppSelf)->getRecentFiles();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getRecentFolder(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getRecentFolder";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getRecentFolder()
            QString cppResult = cppSelf->getRecentFolder();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getRecentProjects(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getRecentProjects";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getRecentProjects()const
            QStringList cppResult = const_cast<const ::Configuration *>(cppSelf)->getRecentProjects();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getSelectedDecompiler(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getSelectedDecompiler";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getSelectedDecompiler()
            QString cppResult = cppSelf->getSelectedDecompiler();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_getZoomFactor(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.getZoomFactor";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getZoomFactor()const
            qreal cppResult = const_cast<const ::Configuration *>(cppSelf)->getZoomFactor();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_instance(PyObject *self)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.instance";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // instance()
            Configuration * cppResult = ::Configuration::instance();
            pyResult = Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX]), cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_isDecompilerAnnotationHighlighterEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.isDecompilerAnnotationHighlighterEnabled";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isDecompilerAnnotationHighlighterEnabled()
            bool cppResult = cppSelf->isDecompilerAnnotationHighlighterEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_isFirstExecution(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.isFirstExecution";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isFirstExecution()
            bool cppResult = cppSelf->isFirstExecution();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_loadInitial(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.loadInitial";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // loadInitial()
            cppSelf->loadInitial();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_ConfigurationFunc_nativeWindowIsDark(PyObject *self)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.nativeWindowIsDark";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // nativeWindowIsDark()
            bool cppResult = ::Configuration::nativeWindowIsDark();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_ConfigurationFunc_refreshFont(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.refreshFont";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // refreshFont()
            cppSelf->refreshFont();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_ConfigurationFunc_resetAll(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.resetAll";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // resetAll()
            cppSelf->resetAll();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_ConfigurationFunc_resetToDefaultAsmOptions(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.resetToDefaultAsmOptions";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // resetToDefaultAsmOptions()
            cppSelf->resetToDefaultAsmOptions();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_ConfigurationFunc_setAutoUpdateEnabled(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setAutoUpdateEnabled";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setAutoUpdateEnabled(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setAutoUpdateEnabled(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setAutoUpdateEnabled_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setAutoUpdateEnabled(bool)
            cppSelf->setAutoUpdateEnabled(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setAutoUpdateEnabled_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setBitmapExportScaleFactor(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setBitmapExportScaleFactor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setBitmapExportScaleFactor(double)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<double>(), (pyArg)))) {
        overloadId = 0; // setBitmapExportScaleFactor(double)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setBitmapExportScaleFactor_TypeError;

    // Call function/method
    {
        double cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setBitmapExportScaleFactor(double)
            cppSelf->setBitmapExportScaleFactor(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setBitmapExportScaleFactor_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setBitmapTransparentState(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setBitmapTransparentState";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setBitmapTransparentState(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setBitmapTransparentState(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setBitmapTransparentState_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setBitmapTransparentState(bool)
            cppSelf->setBitmapTransparentState(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setBitmapTransparentState_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setColor(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setColor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setColor", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: Configuration::setColor(QString,QColor)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QCOLOR_IDX]), (pyArgs[1])))) {
        overloadId = 0; // setColor(QString,QColor)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setColor_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QColor cppArg1_local;
        ::QColor *cppArg1 = &cppArg1_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QCOLOR_IDX]), pythonToCpp[1]))
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);


        if (!PyErr_Occurred()) {
            // setColor(QString,QColor)
            cppSelf->setColor(cppArg0, *cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setColor_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setColorTheme(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setColorTheme";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setColorTheme(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setColorTheme(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setColorTheme_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setColorTheme(QString)
            cppSelf->setColorTheme(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setColorTheme_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setConfig(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setConfig";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setConfig", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: Configuration::setConfig(QString,QVariant)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QVARIANT_IDX], (pyArgs[1])))) {
        overloadId = 0; // setConfig(QString,QVariant)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setConfig_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QVariant cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setConfig(QString,QVariant)
            cppSelf->setConfig(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setConfig_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setDecompilerAutoRefreshEnabled(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setDecompilerAutoRefreshEnabled";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setDecompilerAutoRefreshEnabled(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setDecompilerAutoRefreshEnabled(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setDecompilerAutoRefreshEnabled_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setDecompilerAutoRefreshEnabled(bool)
            cppSelf->setDecompilerAutoRefreshEnabled(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setDecompilerAutoRefreshEnabled_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setFont(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setFont";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setFont(QFont)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QFONT_IDX]), (pyArg)))) {
        overloadId = 0; // setFont(QFont)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setFont_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QFont cppArg0_local;
        ::QFont *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtGuiTypes[SBK_QFONT_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setFont(QFont)
            cppSelf->setFont(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setFont_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setFunctionsWidgetLayout(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setFunctionsWidgetLayout";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setFunctionsWidgetLayout(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setFunctionsWidgetLayout(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setFunctionsWidgetLayout_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setFunctionsWidgetLayout(QString)
            cppSelf->setFunctionsWidgetLayout(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setFunctionsWidgetLayout_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setGraphBlockEntryOffset(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setGraphBlockEntryOffset";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setGraphBlockEntryOffset(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setGraphBlockEntryOffset(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setGraphBlockEntryOffset_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setGraphBlockEntryOffset(bool)
            cppSelf->setGraphBlockEntryOffset(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setGraphBlockEntryOffset_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setGraphBlockMaxChars(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setGraphBlockMaxChars";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setGraphBlockMaxChars(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setGraphBlockMaxChars(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setGraphBlockMaxChars_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setGraphBlockMaxChars(int)
            cppSelf->setGraphBlockMaxChars(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setGraphBlockMaxChars_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setGraphMinFontSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setGraphMinFontSize";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setGraphMinFontSize(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setGraphMinFontSize(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setGraphMinFontSize_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setGraphMinFontSize(int)
            cppSelf->setGraphMinFontSize(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setGraphMinFontSize_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setGraphPreview(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setGraphPreview";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setGraphPreview(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setGraphPreview(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setGraphPreview_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setGraphPreview(bool)
            cppSelf->setGraphPreview(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setGraphPreview_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setGraphSpacing(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setGraphSpacing";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setGraphSpacing", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: Configuration::setGraphSpacing(QPoint,QPoint)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QPOINT_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppValueConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QPOINT_IDX]), (pyArgs[1])))) {
        overloadId = 0; // setGraphSpacing(QPoint,QPoint)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setGraphSpacing_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QPoint cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QPoint cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setGraphSpacing(QPoint,QPoint)
            cppSelf->setGraphSpacing(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setGraphSpacing_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setInterfaceTheme(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setInterfaceTheme";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setInterfaceTheme(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setInterfaceTheme(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setInterfaceTheme_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setInterfaceTheme(int)
            cppSelf->setInterfaceTheme(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setInterfaceTheme_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setLocale(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setLocale";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setLocale(QLocale)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QLOCALE_IDX]), (pyArg)))) {
        overloadId = 0; // setLocale(QLocale)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setLocale_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QLocale cppArg0_local;
        ::QLocale *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QLOCALE_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setLocale(QLocale)
            cppSelf->setLocale(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setLocale_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setLocaleByName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setLocaleByName";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setLocaleByName(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setLocaleByName(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setLocaleByName_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setLocaleByName(QString)
            bool cppResult = cppSelf->setLocaleByName(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_ConfigurationFunc_setLocaleByName_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setNewFileLastClicked(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setNewFileLastClicked";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setNewFileLastClicked(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setNewFileLastClicked(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setNewFileLastClicked_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setNewFileLastClicked(int)
            cppSelf->setNewFileLastClicked(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setNewFileLastClicked_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setOutputRedirectionEnabled(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setOutputRedirectionEnabled";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setOutputRedirectionEnabled(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setOutputRedirectionEnabled(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setOutputRedirectionEnabled_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setOutputRedirectionEnabled(bool)
            cppSelf->setOutputRedirectionEnabled(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setOutputRedirectionEnabled_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setPreviewValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setPreviewValue";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setPreviewValue(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setPreviewValue(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setPreviewValue_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setPreviewValue(bool)
            cppSelf->setPreviewValue(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setPreviewValue_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setRecentFiles(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setRecentFiles";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setRecentFiles(QStringList)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], (pyArg)))) {
        overloadId = 0; // setRecentFiles(QStringList)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setRecentFiles_TypeError;

    // Call function/method
    {
        ::QStringList cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setRecentFiles(QStringList)
            cppSelf->setRecentFiles(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setRecentFiles_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setRecentFolder(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setRecentFolder";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setRecentFolder(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setRecentFolder(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setRecentFolder_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setRecentFolder(QString)
            cppSelf->setRecentFolder(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setRecentFolder_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setRecentProjects(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setRecentProjects";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setRecentProjects(QStringList)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], (pyArg)))) {
        overloadId = 0; // setRecentProjects(QStringList)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setRecentProjects_TypeError;

    // Call function/method
    {
        ::QStringList cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setRecentProjects(QStringList)
            cppSelf->setRecentProjects(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setRecentProjects_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setSelectedDecompiler(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setSelectedDecompiler";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setSelectedDecompiler(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setSelectedDecompiler(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setSelectedDecompiler_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setSelectedDecompiler(QString)
            cppSelf->setSelectedDecompiler(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setSelectedDecompiler_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_setZoomFactor(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.setZoomFactor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Configuration::setZoomFactor(qreal)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArg)))) {
        overloadId = 0; // setZoomFactor(qreal)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_ConfigurationFunc_setZoomFactor_TypeError;

    // Call function/method
    {
        qreal cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setZoomFactor(qreal)
            cppSelf->setZoomFactor(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_ConfigurationFunc_setZoomFactor_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_ConfigurationFunc_windowColorIsDark(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.Configuration.windowColorIsDark";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // windowColorIsDark()
            bool cppResult = cppSelf->windowColorIsDark();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Configuration_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Configuration_methods[] = {
    {"addRecentProject", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_addRecentProject), METH_O},
    {"adjustColorThemeDarkness", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_adjustColorThemeDarkness), METH_NOARGS},
    {"colorThemeDarkness", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_colorThemeDarkness), METH_O},
    {"createSyntaxHighlighter", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_createSyntaxHighlighter), METH_O},
    {"enableDecompilerAnnotationHighlighter", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_enableDecompilerAnnotationHighlighter), METH_O},
    {"getAutoUpdateEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getAutoUpdateEnabled), METH_NOARGS},
    {"getAvailableTranslations", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getAvailableTranslations), METH_NOARGS},
    {"getBaseFont", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getBaseFont), METH_NOARGS},
    {"getBitmapExportScaleFactor", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getBitmapExportScaleFactor), METH_NOARGS},
    {"getBitmapTransparentState", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getBitmapTransparentState), METH_NOARGS},
    {"getColor", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getColor), METH_O},
    {"getColorTheme", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getColorTheme), METH_NOARGS},
    {"getConfigBool", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getConfigBool), METH_O},
    {"getConfigInt", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getConfigInt), METH_O},
    {"getConfigString", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getConfigString), METH_O},
    {"getConfigVar", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getConfigVar), METH_O},
    {"getCurrLocale", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getCurrLocale), METH_NOARGS},
    {"getDecompilerAutoRefreshEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getDecompilerAutoRefreshEnabled), METH_NOARGS},
    {"getFont", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getFont), METH_NOARGS},
    {"getFunctionsWidgetLayout", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getFunctionsWidgetLayout), METH_NOARGS},
    {"getGraphBlockEntryOffset", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getGraphBlockEntryOffset), METH_NOARGS},
    {"getGraphBlockMaxChars", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getGraphBlockMaxChars), METH_NOARGS},
    {"getGraphBlockSpacing", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getGraphBlockSpacing), METH_NOARGS},
    {"getGraphEdgeSpacing", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getGraphEdgeSpacing), METH_NOARGS},
    {"getGraphMinFontSize", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getGraphMinFontSize), METH_NOARGS},
    {"getGraphPreview", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getGraphPreview), METH_NOARGS},
    {"getInterfaceTheme", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getInterfaceTheme), METH_NOARGS},
    {"getLogoFile", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getLogoFile), METH_NOARGS},
    {"getNewFileLastClicked", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getNewFileLastClicked), METH_NOARGS},
    {"getOutputRedirectionEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getOutputRedirectionEnabled), METH_NOARGS},
    {"getPreviewValue", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getPreviewValue), METH_NOARGS},
    {"getRecentFiles", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getRecentFiles), METH_NOARGS},
    {"getRecentFolder", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getRecentFolder), METH_NOARGS},
    {"getRecentProjects", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getRecentProjects), METH_NOARGS},
    {"getSelectedDecompiler", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getSelectedDecompiler), METH_NOARGS},
    {"getZoomFactor", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_getZoomFactor), METH_NOARGS},
    {"instance", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_instance), METH_NOARGS|METH_STATIC},
    {"isDecompilerAnnotationHighlighterEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_isDecompilerAnnotationHighlighterEnabled), METH_NOARGS},
    {"isFirstExecution", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_isFirstExecution), METH_NOARGS},
    {"loadInitial", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_loadInitial), METH_NOARGS},
    {"nativeWindowIsDark", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_nativeWindowIsDark), METH_NOARGS|METH_STATIC},
    {"refreshFont", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_refreshFont), METH_NOARGS},
    {"resetAll", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_resetAll), METH_NOARGS},
    {"resetToDefaultAsmOptions", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_resetToDefaultAsmOptions), METH_NOARGS},
    {"setAutoUpdateEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setAutoUpdateEnabled), METH_O},
    {"setBitmapExportScaleFactor", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setBitmapExportScaleFactor), METH_O},
    {"setBitmapTransparentState", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setBitmapTransparentState), METH_O},
    {"setColor", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setColor), METH_VARARGS},
    {"setColorTheme", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setColorTheme), METH_O},
    {"setConfig", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setConfig), METH_VARARGS},
    {"setDecompilerAutoRefreshEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setDecompilerAutoRefreshEnabled), METH_O},
    {"setFont", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setFont), METH_O},
    {"setFunctionsWidgetLayout", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setFunctionsWidgetLayout), METH_O},
    {"setGraphBlockEntryOffset", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setGraphBlockEntryOffset), METH_O},
    {"setGraphBlockMaxChars", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setGraphBlockMaxChars), METH_O},
    {"setGraphMinFontSize", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setGraphMinFontSize), METH_O},
    {"setGraphPreview", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setGraphPreview), METH_O},
    {"setGraphSpacing", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setGraphSpacing), METH_VARARGS},
    {"setInterfaceTheme", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setInterfaceTheme), METH_O},
    {"setLocale", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setLocale), METH_O},
    {"setLocaleByName", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setLocaleByName), METH_O},
    {"setNewFileLastClicked", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setNewFileLastClicked), METH_O},
    {"setOutputRedirectionEnabled", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setOutputRedirectionEnabled), METH_O},
    {"setPreviewValue", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setPreviewValue), METH_O},
    {"setRecentFiles", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setRecentFiles), METH_O},
    {"setRecentFolder", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setRecentFolder), METH_O},
    {"setRecentProjects", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setRecentProjects), METH_O},
    {"setSelectedDecompiler", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setSelectedDecompiler), METH_O},
    {"setZoomFactor", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_setZoomFactor), METH_O},
    {"windowColorIsDark", reinterpret_cast<PyCFunction>(Sbk_ConfigurationFunc_windowColorIsDark), METH_NOARGS},

    {nullptr, nullptr} // Sentinel
};

static int Sbk_Configuration_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value && PyCallable_Check(value)) {
        auto plain_inst = reinterpret_cast< ::Configuration *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX], reinterpret_cast<SbkObject *>(self)));
        auto inst = dynamic_cast<ConfigurationWrapper *>(plain_inst);
        if (inst)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_Configuration_traverse(PyObject *self, visitproc visit, void *arg)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_traverse(self, visit, arg);
}
static int Sbk_Configuration_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType *_Sbk_Configuration_Type = nullptr;
static SbkObjectType *Sbk_Configuration_TypeF(void)
{
    return _Sbk_Configuration_Type;
}

static PyType_Slot Sbk_Configuration_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_Configuration_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Configuration_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Configuration_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Configuration_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        nullptr},
    {Py_tp_new,         reinterpret_cast<void *>(SbkDummyNew /* PYSIDE-595: Prevent replacement of "0" with base->tp_new. */)},
    {0, nullptr}
};
static PyType_Spec Sbk_Configuration_spec = {
    "1:CutterBindings.Configuration",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    Sbk_Configuration_slots
};

} //extern "C"

static void *Sbk_Configuration_typeDiscovery(void *cptr, SbkObjectType *instanceType)
{
    if (instanceType == reinterpret_cast<SbkObjectType *>(Shiboken::SbkType< ::QObject >()))
        return dynamic_cast< ::Configuration *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void Configuration_PythonToCpp_Configuration_PTR(PyObject *pyIn, void *cppOut) {
    Shiboken::Conversions::pythonToCppPointer(Sbk_Configuration_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_Configuration_PythonToCpp_Configuration_PTR_Convertible(PyObject *pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_Configuration_TypeF())))
        return Configuration_PythonToCpp_Configuration_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *Configuration_PTR_CppToPython_Configuration(const void *cppIn) {
    return PySide::getWrapperForQObject(reinterpret_cast<::Configuration *>(const_cast<void *>(cppIn)), Sbk_Configuration_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Configuration_SignatureStrings[] = {
    "CutterBindings.Configuration.addRecentProject(self,file:QString)",
    "CutterBindings.Configuration.adjustColorThemeDarkness(self)",
    "CutterBindings.Configuration.colorThemeDarkness(self,colorTheme:QString)->int",
    "CutterBindings.Configuration.createSyntaxHighlighter(self,document:PySide2.QtGui.QTextDocument)->PySide2.QtGui.QSyntaxHighlighter",
    "CutterBindings.Configuration.enableDecompilerAnnotationHighlighter(self,useDecompilerHighlighter:bool)",
    "CutterBindings.Configuration.getAutoUpdateEnabled(self)->bool",
    "CutterBindings.Configuration.getAvailableTranslations(self)->QStringList",
    "CutterBindings.Configuration.getBaseFont(self)->PySide2.QtGui.QFont",
    "CutterBindings.Configuration.getBitmapExportScaleFactor(self)->double",
    "CutterBindings.Configuration.getBitmapTransparentState(self)->bool",
    "CutterBindings.Configuration.getColor(self,name:QString)->PySide2.QtGui.QColor",
    "CutterBindings.Configuration.getColorTheme(self)->QString",
    "CutterBindings.Configuration.getConfigBool(self,key:QString)->bool",
    "CutterBindings.Configuration.getConfigInt(self,key:QString)->int",
    "CutterBindings.Configuration.getConfigString(self,key:QString)->QString",
    "CutterBindings.Configuration.getConfigVar(self,key:QString)->QVariant",
    "CutterBindings.Configuration.getCurrLocale(self)->PySide2.QtCore.QLocale",
    "CutterBindings.Configuration.getDecompilerAutoRefreshEnabled(self)->bool",
    "CutterBindings.Configuration.getFont(self)->PySide2.QtGui.QFont",
    "CutterBindings.Configuration.getFunctionsWidgetLayout(self)->QString",
    "CutterBindings.Configuration.getGraphBlockEntryOffset(self)->bool",
    "CutterBindings.Configuration.getGraphBlockMaxChars(self)->int",
    "CutterBindings.Configuration.getGraphBlockSpacing(self)->PySide2.QtCore.QPoint",
    "CutterBindings.Configuration.getGraphEdgeSpacing(self)->PySide2.QtCore.QPoint",
    "CutterBindings.Configuration.getGraphMinFontSize(self)->int",
    "CutterBindings.Configuration.getGraphPreview(self)->bool",
    "CutterBindings.Configuration.getInterfaceTheme(self)->int",
    "CutterBindings.Configuration.getLogoFile(self)->QString",
    "CutterBindings.Configuration.getNewFileLastClicked(self)->int",
    "CutterBindings.Configuration.getOutputRedirectionEnabled(self)->bool",
    "CutterBindings.Configuration.getPreviewValue(self)->bool",
    "CutterBindings.Configuration.getRecentFiles(self)->QStringList",
    "CutterBindings.Configuration.getRecentFolder(self)->QString",
    "CutterBindings.Configuration.getRecentProjects(self)->QStringList",
    "CutterBindings.Configuration.getSelectedDecompiler(self)->QString",
    "CutterBindings.Configuration.getZoomFactor(self)->qreal",
    "CutterBindings.Configuration.instance()->CutterBindings.Configuration",
    "CutterBindings.Configuration.isDecompilerAnnotationHighlighterEnabled(self)->bool",
    "CutterBindings.Configuration.isFirstExecution(self)->bool",
    "CutterBindings.Configuration.loadInitial(self)",
    "CutterBindings.Configuration.nativeWindowIsDark()->bool",
    "CutterBindings.Configuration.refreshFont(self)",
    "CutterBindings.Configuration.resetAll(self)",
    "CutterBindings.Configuration.resetToDefaultAsmOptions(self)",
    "CutterBindings.Configuration.setAutoUpdateEnabled(self,au:bool)",
    "CutterBindings.Configuration.setBitmapExportScaleFactor(self,inputValueGraph:double)",
    "CutterBindings.Configuration.setBitmapTransparentState(self,inputValueGraph:bool)",
    "CutterBindings.Configuration.setColor(self,name:QString,color:PySide2.QtGui.QColor)",
    "CutterBindings.Configuration.setColorTheme(self,theme:QString)",
    "CutterBindings.Configuration.setConfig(self,key:QString,value:QVariant)",
    "CutterBindings.Configuration.setDecompilerAutoRefreshEnabled(self,enabled:bool)",
    "CutterBindings.Configuration.setFont(self,font:PySide2.QtGui.QFont)",
    "CutterBindings.Configuration.setFunctionsWidgetLayout(self,layout:QString)",
    "CutterBindings.Configuration.setGraphBlockEntryOffset(self,enabled:bool)",
    "CutterBindings.Configuration.setGraphBlockMaxChars(self,ch:int)",
    "CutterBindings.Configuration.setGraphMinFontSize(self,sz:int)",
    "CutterBindings.Configuration.setGraphPreview(self,checked:bool)",
    "CutterBindings.Configuration.setGraphSpacing(self,blockSpacing:PySide2.QtCore.QPoint,edgeSpacing:PySide2.QtCore.QPoint)",
    "CutterBindings.Configuration.setInterfaceTheme(self,theme:int)",
    "CutterBindings.Configuration.setLocale(self,l:PySide2.QtCore.QLocale)",
    "CutterBindings.Configuration.setLocaleByName(self,language:QString)->bool",
    "CutterBindings.Configuration.setNewFileLastClicked(self,lastClicked:int)",
    "CutterBindings.Configuration.setOutputRedirectionEnabled(self,enabled:bool)",
    "CutterBindings.Configuration.setPreviewValue(self,checked:bool)",
    "CutterBindings.Configuration.setRecentFiles(self,list:QStringList)",
    "CutterBindings.Configuration.setRecentFolder(self,dir:QString)",
    "CutterBindings.Configuration.setRecentProjects(self,list:QStringList)",
    "CutterBindings.Configuration.setSelectedDecompiler(self,id:QString)",
    "CutterBindings.Configuration.setZoomFactor(self,zoom:qreal)",
    "CutterBindings.Configuration.windowColorIsDark(self)->bool",
    nullptr}; // Sentinel

void init_Configuration(PyObject *module)
{
    _Sbk_Configuration_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "Configuration",
        "Configuration*",
        &Sbk_Configuration_spec,
        &Shiboken::callCppDestructor< ::Configuration >,
        reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QOBJECT_IDX]),
        0,
        0    );
    
    auto pyType = reinterpret_cast<PyTypeObject *>(_Sbk_Configuration_Type);
    InitSignatureStrings(pyType, Configuration_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_Configuration_Type), Sbk_Configuration_PropertyStrings);
    SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX]
        = reinterpret_cast<PyTypeObject *>(Sbk_Configuration_TypeF());

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_Configuration_TypeF(),
        Configuration_PythonToCpp_Configuration_PTR,
        is_Configuration_PythonToCpp_Configuration_PTR_Convertible,
        Configuration_PTR_CppToPython_Configuration);

    Shiboken::Conversions::registerConverterName(converter, "Configuration");
    Shiboken::Conversions::registerConverterName(converter, "Configuration*");
    Shiboken::Conversions::registerConverterName(converter, "Configuration&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Configuration).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(::ConfigurationWrapper).name());


    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(Sbk_Configuration_TypeF(), &Sbk_Configuration_typeDiscovery);

    PySide::Signal::registerSignals(Sbk_Configuration_TypeF(), &::Configuration::staticMetaObject);
    Shiboken::ObjectType::setSubTypeInitHook(Sbk_Configuration_TypeF(), &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(Sbk_Configuration_TypeF(), &::Configuration::staticMetaObject, sizeof(ConfigurationWrapper));
}
