

#ifndef SBK_CUTTERBINDINGS_PYTHON_H
#define SBK_CUTTERBINDINGS_PYTHON_H

//workaround to access protected functions
#define protected public

#include <sbkpython.h>
#include <sbkconverter.h>
// Module Includes
#include <pyside2_qtcore_python.h>
#include <pyside2_qtgui_python.h>
#include <pyside2_qtwidgets_python.h>

// Bound library includes
#include <MainWindow.h>
#include <Configuration.h>
#include <AddressableItemContextMenu.h>
#include <BasicBlockHighlighter.h>
#include <CutterDockWidget.h>
#include <Cutter.h>
#include <CutterPlugin.h>
// Conversion Includes - Primitive Types
#include <qabstractitemmodel.h>
#include <QString>
#include <QStringList>
#include <signalmanager.h>

// Conversion Includes - Container Types
#include <pysideqflags.h>
#include <QLinkedList>
#include <QList>
#include <QMap>
#include <QMultiMap>
#include <QPair>
#include <QQueue>
#include <QSet>
#include <QStack>
#include <QVector>

// Type indices
enum : int {
    SBK_ADDRESSABLEITEMCONTEXTMENU_IDX                       = 0,
    SBK_BASICBLOCKHIGHLIGHTER_IDX                            = 1,
    SBK_CONFIGURATION_IDX                                    = 2,
    SBK_CUTTERCORE_IDX                                       = 3,
    SBK_CUTTERDOCKWIDGET_IDX                                 = 4,
    SBK_CUTTERPLUGIN_IDX                                     = 5,
    SBK_MAINWINDOW_MENUTYPE_IDX                              = 8,
    SBK_MAINWINDOW_CONTEXTMENUTYPE_IDX                       = 7,
    SBK_MAINWINDOW_IDX                                       = 6,
    SBK_CutterBindings_IDX_COUNT                             = 9
};
// This variable stores all Python types exported by this module.
extern PyTypeObject **SbkCutterBindingsTypes;

// This variable stores the Python module object exported by this module.
extern PyObject *SbkCutterBindingsModuleObject;

// This variable stores all type converters exported by this module.
extern SbkConverter **SbkCutterBindingsTypeConverters;

// Converter indices
enum : int {
    SBK_CUTTERBINDINGS_QLIST_QACTIONPTR_IDX                  = 0, // QList<QAction* >
    SBK_CUTTERBINDINGS_QLIST_QOBJECTPTR_IDX                  = 1, // const QList<QObject* > &
    SBK_CUTTERBINDINGS_QLIST_QBYTEARRAY_IDX                  = 2, // QList<QByteArray >
    SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX                     = 3, // QList<QString >
    SBK_CUTTERBINDINGS_QLIST_UNSIGNEDLONGLONG_IDX            = 4, // QList<unsigned long long >
    SBK_CUTTERBINDINGS_QVECTOR_QSTRING_IDX                   = 5, // QVector<QString >
    SBK_CUTTERBINDINGS_QHASH_QSTRING_QCOLOR_IDX              = 6, // QHash<QString,QColor >
    SBK_CUTTERBINDINGS_QMAP_QSTRING_QVARIANT_IDX             = 7, // const QMap<QString,QVariant > &
    SBK_CUTTERBINDINGS_QLIST_QDOCKWIDGETPTR_IDX              = 8, // const QList<QDockWidget* > &
    SBK_CUTTERBINDINGS_QLIST_INT_IDX                         = 9, // const QList<int > &
    SBK_CUTTERBINDINGS_QLIST_QVARIANT_IDX                    = 10, // QList<QVariant >
    SBK_CutterBindings_CONVERTERS_IDX_COUNT                  = 11
};
// Macros for type check

namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
QT_WARNING_PUSH
QT_WARNING_DISABLE_DEPRECATED
template<> inline PyTypeObject *SbkType< ::AddressableItemContextMenu >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_ADDRESSABLEITEMCONTEXTMENU_IDX]); }
template<> inline PyTypeObject *SbkType< ::BasicBlockHighlighter >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_BASICBLOCKHIGHLIGHTER_IDX]); }
template<> inline PyTypeObject *SbkType< ::Configuration >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX]); }
template<> inline PyTypeObject *SbkType< ::CutterCore >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX]); }
template<> inline PyTypeObject *SbkType< ::CutterDockWidget >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CUTTERDOCKWIDGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::CutterPlugin >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX]); }
template<> inline PyTypeObject *SbkType< ::MainWindow::MenuType >() { return SbkCutterBindingsTypes[SBK_MAINWINDOW_MENUTYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::MainWindow::ContextMenuType >() { return SbkCutterBindingsTypes[SBK_MAINWINDOW_CONTEXTMENUTYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::MainWindow >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_MAINWINDOW_IDX]); }
QT_WARNING_POP

} // namespace Shiboken

#endif // SBK_CUTTERBINDINGS_PYTHON_H

