
//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "cutterbindings_python.h"

// main header
#include "cutterplugin_wrapper.h"

// inner classes

#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}

// Native ---------------------------------------------------------

void CutterPluginWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

CutterPluginWrapper::CutterPluginWrapper() : CutterPlugin()
{
    resetPyMethodCache();
    // ... middle
}

QString CutterPluginWrapper::getAuthor() const
{
    if (m_PyMethodCache[0]) {
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "author");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata author, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getAuthor()' not implemented.");
        return ::QString();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return ::QString();
    static PyObject *nameCache[2] = {};
    static const char *funcName = "getAuthor";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[0] = true;
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "author");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata author, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getAuthor()' not implemented.");
        return ::QString();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return ::QString();
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "CutterPlugin.getAuthor", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
    }
    ::QString cppResult;
    pythonToCpp(pyResult, &cppResult);

    return cppResult;
}

QString CutterPluginWrapper::getDescription() const
{
    if (m_PyMethodCache[1]) {
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "description");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata description, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getDescription()' not implemented.");
        return ::QString();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return ::QString();
    static PyObject *nameCache[2] = {};
    static const char *funcName = "getDescription";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[1] = true;
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "description");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata description, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getDescription()' not implemented.");
        return ::QString();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return ::QString();
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "CutterPlugin.getDescription", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
    }
    ::QString cppResult;
    pythonToCpp(pyResult, &cppResult);

    return cppResult;
}

QString CutterPluginWrapper::getName() const
{
    if (m_PyMethodCache[2]) {
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "name");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata name, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getName()' not implemented.");
        return ::QString();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return ::QString();
    static PyObject *nameCache[2] = {};
    static const char *funcName = "getName";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[2] = true;
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "name");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata name, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getName()' not implemented.");
        return ::QString();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return ::QString();
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "CutterPlugin.getName", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
    }
    ::QString cppResult;
    pythonToCpp(pyResult, &cppResult);

    return cppResult;
}

QString CutterPluginWrapper::getVersion() const
{
    if (m_PyMethodCache[3]) {
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "version");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata version, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getVersion()' not implemented.");
        return ::QString();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return ::QString();
    static PyObject *nameCache[2] = {};
    static const char *funcName = "getVersion";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[3] = true;
        // Begin code injection
        // TEMPLATE - plugin_meta_get - START
        Shiboken::GilState cutterGil;
        SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
        PyObject *classObject = PyObject_GetAttrString(reinterpret_cast<PyObject *>(wrapper), "__class__");
        if (!classObject) {
        PyErr_Print();
        return QString();
        }
        PyObject *pyResult = PyObject_GetAttrString(classObject, "version");
        if (!pyResult) {
        PyErr_Print();
        return QString();
        }
        PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
        if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value for plugin metadata version, expected %s, got %s.", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
        }
        QString cppResult;
        pythonToCpp(pyResult, &cppResult);
        return cppResult;
        // TEMPLATE - plugin_meta_get - END

        // End of code injection

        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getVersion()' not implemented.");
        return ::QString();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return ::QString();
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "CutterPlugin.getVersion", "QString", Py_TYPE(pyResult)->tp_name);
        return ::QString();
    }
    ::QString cppResult;
    pythonToCpp(pyResult, &cppResult);

    return cppResult;
}

void CutterPluginWrapper::registerDecompilers()
{
    if (m_PyMethodCache[4]) {
        return this->::CutterPlugin::registerDecompilers();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "registerDecompilers";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[4] = true;
        return this->::CutterPlugin::registerDecompilers();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

void CutterPluginWrapper::setupInterface(MainWindow * main)
{
    if (m_PyMethodCache[5]) {
        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.setupInterface()' not implemented.");
        return;
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "setupInterface";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[5] = true;
        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.setupInterface()' not implemented.");
        return;
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkCutterBindingsTypes[SBK_MAINWINDOW_IDX]), main)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

void CutterPluginWrapper::setupPlugin()
{
    if (m_PyMethodCache[6]) {
        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.setupPlugin()' not implemented.");
        return;
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "setupPlugin";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[6] = true;
        PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.setupPlugin()' not implemented.");
        return;
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

void CutterPluginWrapper::terminate()
{
    if (m_PyMethodCache[7]) {
        return this->::CutterPlugin::terminate();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "terminate";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[7] = true;
        return this->::CutterPlugin::terminate();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

CutterPluginWrapper::~CutterPluginWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_CutterPlugin_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
    SbkObjectType *type = reinterpret_cast<SbkObjectType *>(self->ob_type);
    SbkObjectType *myType = reinterpret_cast<SbkObjectType *>(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX]);
    if (type == myType) {
        PyErr_SetString(PyExc_NotImplementedError,
            "'CutterPlugin' represents a C++ abstract class and cannot be instantiated");
        return -1;
    }

PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::CutterPlugin >()))
        return -1;

    ::CutterPluginWrapper *cptr{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.__init__";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // CutterPlugin()
            cptr = new ::CutterPluginWrapper();
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::CutterPlugin >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_CutterPluginFunc_getAuthor(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.getAuthor";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getAuthor()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getAuthor()' not implemented.");
                return {};
            }
            QString cppResult = const_cast<const ::CutterPlugin *>(cppSelf)->getAuthor();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterPluginFunc_getDescription(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.getDescription";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getDescription()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getDescription()' not implemented.");
                return {};
            }
            QString cppResult = const_cast<const ::CutterPlugin *>(cppSelf)->getDescription();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterPluginFunc_getName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.getName";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getName()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getName()' not implemented.");
                return {};
            }
            QString cppResult = const_cast<const ::CutterPlugin *>(cppSelf)->getName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterPluginFunc_getVersion(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.getVersion";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getVersion()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.getVersion()' not implemented.");
                return {};
            }
            QString cppResult = const_cast<const ::CutterPlugin *>(cppSelf)->getVersion();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterPluginFunc_registerDecompilers(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.registerDecompilers";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // registerDecompilers()
            Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? cppSelf->::CutterPlugin::registerDecompilers()
                : cppSelf->registerDecompilers();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterPluginFunc_setupInterface(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.setupInterface";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterPlugin::setupInterface(MainWindow*)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppPointerConvertible(reinterpret_cast<SbkObjectType *>(SbkCutterBindingsTypes[SBK_MAINWINDOW_IDX]), (pyArg)))) {
        overloadId = 0; // setupInterface(MainWindow*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterPluginFunc_setupInterface_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::MainWindow *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setupInterface(MainWindow*)
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.setupInterface()' not implemented.");
                return {};
            }
            cppSelf->setupInterface(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterPluginFunc_setupInterface_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterPluginFunc_setupPlugin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.setupPlugin";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // setupPlugin()
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                PyErr_SetString(PyExc_NotImplementedError, "pure virtual method 'CutterPlugin.setupPlugin()' not implemented.");
                return {};
            }
            cppSelf->setupPlugin();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterPluginFunc_terminate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterPlugin.terminate";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // terminate()
            Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? cppSelf->::CutterPlugin::terminate()
                : cppSelf->terminate();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_CutterPlugin_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_CutterPlugin_methods[] = {
    {"getAuthor", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_getAuthor), METH_NOARGS},
    {"getDescription", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_getDescription), METH_NOARGS},
    {"getName", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_getName), METH_NOARGS},
    {"getVersion", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_getVersion), METH_NOARGS},
    {"registerDecompilers", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_registerDecompilers), METH_NOARGS},
    {"setupInterface", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_setupInterface), METH_O},
    {"setupPlugin", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_setupPlugin), METH_NOARGS},
    {"terminate", reinterpret_cast<PyCFunction>(Sbk_CutterPluginFunc_terminate), METH_NOARGS},

    {nullptr, nullptr} // Sentinel
};

static int Sbk_CutterPlugin_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value && PyCallable_Check(value)) {
        auto plain_inst = reinterpret_cast< ::CutterPlugin *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX], reinterpret_cast<SbkObject *>(self)));
        auto inst = dynamic_cast<CutterPluginWrapper *>(plain_inst);
        if (inst)
            inst->resetPyMethodCache();
    }
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_CutterPlugin_traverse(PyObject *self, visitproc visit, void *arg)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_traverse(self, visit, arg);
}
static int Sbk_CutterPlugin_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType *_Sbk_CutterPlugin_Type = nullptr;
static SbkObjectType *Sbk_CutterPlugin_TypeF(void)
{
    return _Sbk_CutterPlugin_Type;
}

static PyType_Slot Sbk_CutterPlugin_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_CutterPlugin_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_CutterPlugin_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_CutterPlugin_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_CutterPlugin_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_CutterPlugin_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_CutterPlugin_spec = {
    "1:CutterBindings.CutterPlugin",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    Sbk_CutterPlugin_slots
};

} //extern "C"


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void CutterPlugin_PythonToCpp_CutterPlugin_PTR(PyObject *pyIn, void *cppOut) {
    Shiboken::Conversions::pythonToCppPointer(Sbk_CutterPlugin_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_CutterPlugin_PythonToCpp_CutterPlugin_PTR_Convertible(PyObject *pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_CutterPlugin_TypeF())))
        return CutterPlugin_PythonToCpp_CutterPlugin_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *CutterPlugin_PTR_CppToPython_CutterPlugin(const void *cppIn) {
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::CutterPlugin *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_CutterPlugin_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *CutterPlugin_SignatureStrings[] = {
    "CutterBindings.CutterPlugin(self)",
    "CutterBindings.CutterPlugin.getAuthor(self)->QString",
    "CutterBindings.CutterPlugin.getDescription(self)->QString",
    "CutterBindings.CutterPlugin.getName(self)->QString",
    "CutterBindings.CutterPlugin.getVersion(self)->QString",
    "CutterBindings.CutterPlugin.registerDecompilers(self)",
    "CutterBindings.CutterPlugin.setupInterface(self,main:CutterBindings.MainWindow)",
    "CutterBindings.CutterPlugin.setupPlugin(self)",
    "CutterBindings.CutterPlugin.terminate(self)",
    nullptr}; // Sentinel

void init_CutterPlugin(PyObject *module)
{
    _Sbk_CutterPlugin_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "CutterPlugin",
        "CutterPlugin*",
        &Sbk_CutterPlugin_spec,
        &Shiboken::callCppDestructor< ::CutterPlugin >,
        0,
        0,
        0    );
    
    auto pyType = reinterpret_cast<PyTypeObject *>(_Sbk_CutterPlugin_Type);
    InitSignatureStrings(pyType, CutterPlugin_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_CutterPlugin_Type), Sbk_CutterPlugin_PropertyStrings);
    SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX]
        = reinterpret_cast<PyTypeObject *>(Sbk_CutterPlugin_TypeF());

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_CutterPlugin_TypeF(),
        CutterPlugin_PythonToCpp_CutterPlugin_PTR,
        is_CutterPlugin_PythonToCpp_CutterPlugin_PTR_Convertible,
        CutterPlugin_PTR_CppToPython_CutterPlugin);

    Shiboken::Conversions::registerConverterName(converter, "CutterPlugin");
    Shiboken::Conversions::registerConverterName(converter, "CutterPlugin*");
    Shiboken::Conversions::registerConverterName(converter, "CutterPlugin&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::CutterPlugin).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(::CutterPluginWrapper).name());


}
