
//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <iterator>

// module include
#include "cutterbindings_python.h"

// main header
#include "cuttercore_wrapper.h"

// inner classes

#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}

// Native ---------------------------------------------------------

void CutterCoreWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

CutterCoreWrapper::CutterCoreWrapper(QObject * parent) : CutterCore(parent)
{
    resetPyMethodCache();
    // ... middle
}

void CutterCoreWrapper::childEvent(QChildEvent * event)
{
    if (m_PyMethodCache[0]) {
        return this->::QObject::childEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "childEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[0] = true;
        return this->::QObject::childEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QCHILDEVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
}

void CutterCoreWrapper::connectNotify(const QMetaMethod & signal)
{
    if (m_PyMethodCache[1]) {
        return this->::QObject::connectNotify(signal);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "connectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[1] = true;
        return this->::QObject::connectNotify(signal);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QMETAMETHOD_IDX]), &signal)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

void CutterCoreWrapper::customEvent(QEvent * event)
{
    if (m_PyMethodCache[2]) {
        return this->::QObject::customEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "customEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[2] = true;
        return this->::QObject::customEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QEVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
}

void CutterCoreWrapper::disconnectNotify(const QMetaMethod & signal)
{
    if (m_PyMethodCache[3]) {
        return this->::QObject::disconnectNotify(signal);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "disconnectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[3] = true;
        return this->::QObject::disconnectNotify(signal);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QMETAMETHOD_IDX]), &signal)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
}

bool CutterCoreWrapper::event(QEvent * event)
{
    if (m_PyMethodCache[4])
        return this->::QObject::event(event);
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "event";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[4] = true;
        return this->::QObject::event(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QEVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return false;
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "CutterCore.event", "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
    return cppResult;
}

bool CutterCoreWrapper::eventFilter(QObject * watched, QEvent * event)
{
    if (m_PyMethodCache[5])
        return this->::QObject::eventFilter(watched, event);
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "eventFilter";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[5] = true;
        return this->::QObject::eventFilter(watched, event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(NN)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QOBJECT_IDX]), watched),
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QEVENT_IDX]), event)
    ));
    bool invalidateArg2 = PyTuple_GET_ITEM(pyArgs, 1)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return false;
    }
    // Check return type
    PythonToCppFunc pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2, "Invalid return value in function %s, expected %s, got %s.", "CutterCore.eventFilter", "bool", Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    if (invalidateArg2)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 1));
    return cppResult;
}

void CutterCoreWrapper::timerEvent(QTimerEvent * event)
{
    if (m_PyMethodCache[7]) {
        return this->::QObject::timerEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "timerEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[7] = true;
        return this->::QObject::timerEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
    Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QTIMEREVENT_IDX]), event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    // An error happened in python code!
    if (pyResult.isNull()) {
        PyErr_Print();
        return;
    }
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
}

const QMetaObject *CutterCoreWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return CutterCore::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int CutterCoreWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = CutterCore::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *CutterCoreWrapper::qt_metacast(const char *_clname)
{
        if (!_clname) return {};
        SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
        if (pySelf && PySide::inherits(Py_TYPE(pySelf), _clname))
                return static_cast<void *>(const_cast< CutterCoreWrapper *>(this));
        return CutterCore::qt_metacast(_clname);
}

CutterCoreWrapper::~CutterCoreWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_CutterCore_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    const QMetaObject *metaObject;
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::CutterCore >()))
        return -1;

    ::CutterCoreWrapper *cptr{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_ParseTuple(args, "|O:CutterCore", &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: CutterCore::CutterCore(QObject*)
    if (numArgs == 0) {
        overloadId = 0; // CutterCore(QObject*)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppPointerConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QOBJECT_IDX]), (pyArgs[0])))) {
        overloadId = 0; // CutterCore(QObject*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCore_Init_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_parent = Shiboken::String::createStaticString("parent");
            if (PyDict_Contains(kwds, key_parent)) {
                value = PyDict_GetItem(kwds, key_parent);
                if (value && pyArgs[0]) {
                    errInfo = key_parent;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCore_Init_TypeError;
                }
                if (value) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::isPythonToCppPointerConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QOBJECT_IDX]), (pyArgs[0]))))
                        goto Sbk_CutterCore_Init_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_parent);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                // fall through to handle extra keyword signals and properties
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QObject *cppArg0 = nullptr;
        if (pythonToCpp[0]) pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!PyErr_Occurred()) {
            // CutterCore(QObject*)
            void *addr = PySide::nextQObjectMemoryAddr();
            if (addr) {
                cptr = new (addr) ::CutterCoreWrapper(cppArg0);
                PySide::setNextQObjectMemoryAddr(0);
            } else {
                cptr = new ::CutterCoreWrapper(cppArg0);
            }

            Shiboken::Object::setParent(pyArgs[0], self);
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::CutterCore >(), cptr)) {
        delete cptr;
        Py_XDECREF(errInfo);
        return -1;
    }
    if (!cptr) goto Sbk_CutterCore_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);

    // QObject setup
    PySide::Signal::updateSourceObject(self);
    metaObject = cptr->metaObject(); // <- init python qt properties
    if (errInfo && PyDict_Check(errInfo)) {
        if (!PySide::fillQtProperties(self, metaObject, errInfo))
            goto Sbk_CutterCore_Init_TypeError;
        Py_DECREF(errInfo);
    };


    return 1;

    Sbk_CutterCore_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return -1;
}

static PyObject *Sbk_CutterCoreFunc_addFlag(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.addFlag";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "addFlag", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::addFlag(unsigned long long,QString,unsigned long long)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[2])))) {
        overloadId = 0; // addFlag(unsigned long long,QString,unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_addFlag_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        unsigned long long cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // addFlag(unsigned long long,QString,unsigned long long)
            cppSelf->addFlag(cppArg0, cppArg1, cppArg2);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_addFlag_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_ansiEscapeToHtml(PyObject *self, PyObject *pyArg)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.ansiEscapeToHtml";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static CutterCore::ansiEscapeToHtml(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // ansiEscapeToHtml(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_ansiEscapeToHtml_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // ansiEscapeToHtml(QString)
            QString cppResult = ::CutterCore::ansiEscapeToHtml(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_ansiEscapeToHtml_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_applySignature(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.applySignature";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::applySignature(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // applySignature(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_applySignature_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // applySignature(QString)
            cppSelf->applySignature(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_applySignature_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_applyStructureOffset(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.applyStructureOffset";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths
    if (numArgs > 2) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_applyStructureOffset_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_applyStructureOffset_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OO:applyStructureOffset", &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::applyStructureOffset(QString,unsigned long long)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // applyStructureOffset(QString,unsigned long long)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
            overloadId = 0; // applyStructureOffset(QString,unsigned long long)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_applyStructureOffset_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_offset = Shiboken::String::createStaticString("offset");
            if (PyDict_Contains(kwds, key_offset)) {
                value = PyDict_GetItem(kwds, key_offset);
                if (value && pyArgs[1]) {
                    errInfo = key_offset;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_applyStructureOffset_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_applyStructureOffset_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_offset);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_applyStructureOffset_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1 = RVA_INVALID;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // applyStructureOffset(QString,unsigned long long)
            cppSelf->applyStructureOffset(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_applyStructureOffset_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_assemble(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.assemble";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::assemble(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // assemble(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_assemble_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // assemble(QString)
            QByteArray cppResult = cppSelf->assemble(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_assemble_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_attachDebug(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.attachDebug";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::attachDebug(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // attachDebug(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_attachDebug_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // attachDebug(int)
            cppSelf->attachDebug(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_attachDebug_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_attachRemote(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.attachRemote";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::attachRemote(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // attachRemote(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_attachRemote_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // attachRemote(QString)
            cppSelf->attachRemote(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_attachRemote_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_breakpointIndexAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.breakpointIndexAt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::breakpointIndexAt(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // breakpointIndexAt(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_breakpointIndexAt_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // breakpointIndexAt(unsigned long long)
            int cppResult = cppSelf->breakpointIndexAt(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_breakpointIndexAt_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_bytesToHexString(PyObject *self, PyObject *pyArg)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.bytesToHexString";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static CutterCore::bytesToHexString(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), (pyArg)))) {
        overloadId = 0; // bytesToHexString(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_bytesToHexString_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // bytesToHexString(QByteArray)
            QString cppResult = ::CutterCore::bytesToHexString(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_bytesToHexString_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_cmd(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.cmd";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::cmd(QString)
    // 1: CutterCore::cmd(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 1; // cmd(const char*)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // cmd(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_cmd_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // cmd(const QString & str)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // cmd(QString)
                QString cppResult = cppSelf->cmd(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
        case 1: // cmd(const char * str)
        {
            const char* cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // cmd(const char*)
                QString cppResult = cppSelf->cmd(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_cmd_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_cmdRaw(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.cmdRaw";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::cmdRaw(QString)
    // 1: CutterCore::cmdRaw(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 1; // cmdRaw(const char*)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // cmdRaw(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_cmdRaw_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // cmdRaw(const QString & cmd)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // cmdRaw(QString)
                QString cppResult = cppSelf->cmdRaw(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
        case 1: // cmdRaw(const char * cmd)
        {
            const char* cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // cmdRaw(const char*)
                QString cppResult = cppSelf->cmdRaw(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_cmdRaw_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_cmdRawAt(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.cmdRawAt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "cmdRawAt", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::cmdRawAt(QString,unsigned long long)
    // 1: CutterCore::cmdRawAt(const char*,unsigned long long)
    if (numArgs == 2
        && Shiboken::String::check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
        overloadId = 1; // cmdRawAt(const char*,unsigned long long)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
        overloadId = 0; // cmdRawAt(QString,unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_cmdRawAt_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // cmdRawAt(const QString & str, unsigned long long address)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            unsigned long long cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // cmdRawAt(QString,unsigned long long)
                QString cppResult = cppSelf->cmdRawAt(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
        case 1: // cmdRawAt(const char * cmd, unsigned long long address)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            unsigned long long cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // cmdRawAt(const char*,unsigned long long)
                QString cppResult = cppSelf->cmdRawAt(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_cmdRawAt_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_cmdTask(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.cmdTask";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::cmdTask(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // cmdTask(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_cmdTask_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // cmdTask(QString)
            QString cppResult = cppSelf->cmdTask(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_cmdTask_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_commitWriteCache(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.commitWriteCache";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // commitWriteCache()
            cppSelf->commitWriteCache();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_continueBackDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.continueBackDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // continueBackDebug()
            cppSelf->continueBackDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_continueDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.continueDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // continueDebug()
            cppSelf->continueDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_continueUntilCall(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.continueUntilCall";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // continueUntilCall()
            cppSelf->continueUntilCall();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_continueUntilDebug(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.continueUntilDebug";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::continueUntilDebug(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // continueUntilDebug(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_continueUntilDebug_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // continueUntilDebug(unsigned long long)
            cppSelf->continueUntilDebug(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_continueUntilDebug_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_continueUntilSyscall(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.continueUntilSyscall";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // continueUntilSyscall()
            cppSelf->continueUntilSyscall();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_createFunctionAt(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.createFunctionAt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "createFunctionAt", 1, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::createFunctionAt(unsigned long long)
    // 1: CutterCore::createFunctionAt(unsigned long long,QString)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // createFunctionAt(unsigned long long)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
            overloadId = 1; // createFunctionAt(unsigned long long,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_createFunctionAt_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // createFunctionAt(unsigned long long addr)
        {
            unsigned long long cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!PyErr_Occurred()) {
                // createFunctionAt(unsigned long long)
                cppSelf->createFunctionAt(cppArg0);
            }
            break;
        }
        case 1: // createFunctionAt(unsigned long long addr, QString name)
        {
            unsigned long long cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // createFunctionAt(unsigned long long,QString)
                cppSelf->createFunctionAt(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_createFunctionAt_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_createNewClass(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.createNewClass";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::createNewClass(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // createNewClass(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_createNewClass_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // createNewClass(QString)
            cppSelf->createNewClass(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_createNewClass_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_createSignature(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.createSignature";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::createSignature(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // createSignature(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_createSignature_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // createSignature(QString)
            cppSelf->createSignature(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_createSignature_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_delAllBreakpoints(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.delAllBreakpoints";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // delAllBreakpoints()
            cppSelf->delAllBreakpoints();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_delBreakpoint(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.delBreakpoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::delBreakpoint(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // delBreakpoint(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_delBreakpoint_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // delBreakpoint(unsigned long long)
            cppSelf->delBreakpoint(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_delBreakpoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_delComment(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.delComment";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::delComment(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // delComment(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_delComment_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // delComment(unsigned long long)
            cppSelf->delComment(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_delComment_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_delFlag(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.delFlag";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::delFlag(QString)
    // 1: CutterCore::delFlag(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 1; // delFlag(unsigned long long)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // delFlag(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_delFlag_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // delFlag(const QString & name)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // delFlag(QString)
                cppSelf->delFlag(cppArg0);
            }
            break;
        }
        case 1: // delFlag(unsigned long long addr)
        {
            unsigned long long cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // delFlag(unsigned long long)
                cppSelf->delFlag(cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_delFlag_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_delFunction(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.delFunction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::delFunction(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // delFunction(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_delFunction_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // delFunction(unsigned long long)
            cppSelf->delFunction(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_delFunction_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_deleteClass(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.deleteClass";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::deleteClass(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // deleteClass(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_deleteClass_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // deleteClass(QString)
            cppSelf->deleteClass(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_deleteClass_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_disableBreakpoint(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.disableBreakpoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::disableBreakpoint(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // disableBreakpoint(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_disableBreakpoint_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // disableBreakpoint(unsigned long long)
            cppSelf->disableBreakpoint(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_disableBreakpoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_disassemble(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.disassemble";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::disassemble(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppReferenceConvertible(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), (pyArg)))) {
        overloadId = 0; // disassemble(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_disassemble_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (Shiboken::Conversions::isImplicitConversion(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), pythonToCpp))
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // disassemble(QByteArray)
            QString cppResult = cppSelf->disassemble(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_disassemble_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_disassembleSingleInstruction(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.disassembleSingleInstruction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::disassembleSingleInstruction(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // disassembleSingleInstruction(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_disassembleSingleInstruction_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // disassembleSingleInstruction(unsigned long long)
            QString cppResult = cppSelf->disassembleSingleInstruction(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_disassembleSingleInstruction_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_editBytes(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.editBytes";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "editBytes", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::editBytes(unsigned long long,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // editBytes(unsigned long long,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_editBytes_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // editBytes(unsigned long long,QString)
            cppSelf->editBytes(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_editBytes_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_editBytesEndian(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.editBytesEndian";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "editBytesEndian", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::editBytesEndian(unsigned long long,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // editBytesEndian(unsigned long long,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_editBytesEndian_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // editBytesEndian(unsigned long long,QString)
            cppSelf->editBytesEndian(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_editBytesEndian_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_editInstruction(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.editInstruction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths
    if (numArgs > 3) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_editInstruction_TypeError;
    } else if (numArgs < 2) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_editInstruction_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OOO:editInstruction", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::editInstruction(unsigned long long,QString,bool)
    if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 0; // editInstruction(unsigned long long,QString,bool)
        } else if (numArgs >= 3
            && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[2])))) {
            overloadId = 0; // editInstruction(unsigned long long,QString,bool)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_editInstruction_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_fillWithNops = Shiboken::String::createStaticString("fillWithNops");
            if (PyDict_Contains(kwds, key_fillWithNops)) {
                value = PyDict_GetItem(kwds, key_fillWithNops);
                if (value && pyArgs[2]) {
                    errInfo = key_fillWithNops;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_editInstruction_TypeError;
                }
                if (value) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[2]))))
                        goto Sbk_CutterCoreFunc_editInstruction_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_fillWithNops);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_editInstruction_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        bool cppArg2 = false;
        if (pythonToCpp[2]) pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // editInstruction(unsigned long long,QString,bool)
            cppSelf->editInstruction(cppArg0, cppArg1, cppArg2);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_editInstruction_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_enableBreakpoint(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.enableBreakpoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::enableBreakpoint(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // enableBreakpoint(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_enableBreakpoint_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // enableBreakpoint(unsigned long long)
            cppSelf->enableBreakpoint(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_enableBreakpoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_existsFileInfo(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.existsFileInfo";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // existsFileInfo()
            bool cppResult = cppSelf->existsFileInfo();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_flagAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.flagAt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::flagAt(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // flagAt(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_flagAt_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // flagAt(unsigned long long)
            QString cppResult = cppSelf->flagAt(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_flagAt_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getActiveDebugPlugin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getActiveDebugPlugin";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getActiveDebugPlugin()
            QString cppResult = cppSelf->getActiveDebugPlugin();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getAllAnalysisClasses(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getAllAnalysisClasses";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getAllAnalysisClasses(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // getAllAnalysisClasses(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getAllAnalysisClasses_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getAllAnalysisClasses(bool)
            QList<QString > cppResult = cppSelf->getAllAnalysisClasses(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getAllAnalysisClasses_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getAnalysisPluginNames(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getAnalysisPluginNames";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getAnalysisPluginNames()
            QStringList cppResult = cppSelf->getAnalysisPluginNames();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getArchBits(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getArchBits";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getArchBits()
            int cppResult = cppSelf->getArchBits();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getAsmPluginNames(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getAsmPluginNames";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getAsmPluginNames()
            QStringList cppResult = cppSelf->getAsmPluginNames();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getBBHighlighter(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getBBHighlighter";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getBBHighlighter()
            BasicBlockHighlighter * cppResult = cppSelf->getBBHighlighter();
            pyResult = Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkCutterBindingsTypes[SBK_BASICBLOCKHIGHLIGHTER_IDX]), cppResult);
            Shiboken::Object::setParent(self, pyResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getBreakpointsAddresses(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getBreakpointsAddresses";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getBreakpointsAddresses()
            QList<unsigned long long > cppResult = cppSelf->getBreakpointsAddresses();
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_UNSIGNEDLONGLONG_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getBreakpointsInFunction(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getBreakpointsInFunction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getBreakpointsInFunction(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getBreakpointsInFunction(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getBreakpointsInFunction_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getBreakpointsInFunction(unsigned long long)
            QList<unsigned long long > cppResult = cppSelf->getBreakpointsInFunction(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_UNSIGNEDLONGLONG_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getBreakpointsInFunction_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getColorThemes(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getColorThemes";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getColorThemes()
            QStringList cppResult = cppSelf->getColorThemes();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getCommentAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getCommentAt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getCommentAt(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getCommentAt(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getCommentAt_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getCommentAt(unsigned long long)
            QString cppResult = cppSelf->getCommentAt(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getCommentAt_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfig(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfig";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getConfig(QString)
    // 1: CutterCore::getConfig(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 1; // getConfig(const char*)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfig(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfig_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // getConfig(const QString & k)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfig(QString)
                QString cppResult = cppSelf->getConfig(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
        case 1: // getConfig(const char * k)
        {
            const char* cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfig(const char*)
                QString cppResult = cppSelf->getConfig(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfig_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfigDescription(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfigDescription";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getConfigDescription(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 0; // getConfigDescription(const char*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfigDescription_TypeError;

    // Call function/method
    {
        const char* cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigDescription(const char*)
            QString cppResult = cppSelf->getConfigDescription(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfigDescription_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfigOptions(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfigOptions";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getConfigOptions(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 0; // getConfigOptions(const char*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfigOptions_TypeError;

    // Call function/method
    {
        const char* cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigOptions(const char*)
            QStringList cppResult = cppSelf->getConfigOptions(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfigOptions_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfigVariableSpaces(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfigVariableSpaces";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths
    if (numArgs > 1) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_getConfigVariableSpaces_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|O:getConfigVariableSpaces", &(pyArgs[0])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::getConfigVariableSpaces(QString)
    if (numArgs == 0) {
        overloadId = 0; // getConfigVariableSpaces(QString)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))) {
        overloadId = 0; // getConfigVariableSpaces(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfigVariableSpaces_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_key = Shiboken::String::createStaticString("key");
            if (PyDict_Contains(kwds, key_key)) {
                value = PyDict_GetItem(kwds, key_key);
                if (value && pyArgs[0]) {
                    errInfo = key_key;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_getConfigVariableSpaces_TypeError;
                }
                if (value) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0]))))
                        goto Sbk_CutterCoreFunc_getConfigVariableSpaces_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_key);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_getConfigVariableSpaces_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        ::QString cppArg0 = "";
        if (pythonToCpp[0]) pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!PyErr_Occurred()) {
            // getConfigVariableSpaces(QString)
            QStringList cppResult = cppSelf->getConfigVariableSpaces(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfigVariableSpaces_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfigb(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfigb";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getConfigb(QString)
    // 1: CutterCore::getConfigb(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 1; // getConfigb(const char*)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigb(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfigb_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // getConfigb(const QString & k)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfigb(QString)
                bool cppResult = cppSelf->getConfigb(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // getConfigb(const char * k)
        {
            const char* cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfigb(const char*)
                bool cppResult = cppSelf->getConfigb(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfigb_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfigi(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfigi";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getConfigi(QString)
    // 1: CutterCore::getConfigi(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 1; // getConfigi(const char*)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigi(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfigi_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // getConfigi(const QString & k)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfigi(QString)
                int cppResult = cppSelf->getConfigi(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
            }
            break;
        }
        case 1: // getConfigi(const char * k)
        {
            const char* cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfigi(const char*)
                int cppResult = cppSelf->getConfigi(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfigi_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getConfigut64(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getConfigut64";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getConfigut64(QString)
    // 1: CutterCore::getConfigut64(const char*)
    if (Shiboken::String::check(pyArg) && (pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArg)))) {
        overloadId = 1; // getConfigut64(const char*)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getConfigut64(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getConfigut64_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // getConfigut64(const QString & k)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfigut64(QString)
                unsigned long long cppResult = cppSelf->getConfigut64(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
            }
            break;
        }
        case 1: // getConfigut64(const char * k)
        {
            const char* cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // getConfigut64(const char*)
                unsigned long long cppResult = cppSelf->getConfigut64(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getConfigut64_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getCutterRCDefaultDirectory(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getCutterRCDefaultDirectory";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getCutterRCDefaultDirectory()const
            QDir cppResult = const_cast<const ::CutterCore *>(cppSelf)->getCutterRCDefaultDirectory();
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QDIR_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getDebugPlugins(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getDebugPlugins";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getDebugPlugins()
            QStringList cppResult = cppSelf->getDebugPlugins();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getDisassemblyPreview(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getDisassemblyPreview";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "getDisassemblyPreview", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::getDisassemblyPreview(unsigned long long,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 0; // getDisassemblyPreview(unsigned long long,int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getDisassemblyPreview_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // getDisassemblyPreview(unsigned long long,int)
            QStringList cppResult = cppSelf->getDisassemblyPreview(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getDisassemblyPreview_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getFunctionEnd(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getFunctionEnd";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getFunctionEnd(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getFunctionEnd(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getFunctionEnd_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getFunctionEnd(unsigned long long)
            unsigned long long cppResult = cppSelf->getFunctionEnd(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getFunctionEnd_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getFunctionStart(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getFunctionStart";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getFunctionStart(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getFunctionStart(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getFunctionStart_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getFunctionStart(unsigned long long)
            unsigned long long cppResult = cppSelf->getFunctionStart(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getFunctionStart_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getHexdumpPreview(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getHexdumpPreview";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "getHexdumpPreview", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::getHexdumpPreview(unsigned long long,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 0; // getHexdumpPreview(unsigned long long,int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getHexdumpPreview_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // getHexdumpPreview(unsigned long long,int)
            QString cppResult = cppSelf->getHexdumpPreview(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getHexdumpPreview_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getInstructionBytes(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getInstructionBytes";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getInstructionBytes(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getInstructionBytes(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getInstructionBytes_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getInstructionBytes(unsigned long long)
            QString cppResult = cppSelf->getInstructionBytes(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getInstructionBytes_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getInstructionOpcode(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getInstructionOpcode";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getInstructionOpcode(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getInstructionOpcode(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getInstructionOpcode_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getInstructionOpcode(unsigned long long)
            QString cppResult = cppSelf->getInstructionOpcode(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getInstructionOpcode_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getLastFunctionInstruction(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getLastFunctionInstruction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getLastFunctionInstruction(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getLastFunctionInstruction(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getLastFunctionInstruction_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getLastFunctionInstruction(unsigned long long)
            unsigned long long cppResult = cppSelf->getLastFunctionInstruction(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getLastFunctionInstruction_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getMetaString(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getMetaString";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getMetaString(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getMetaString(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getMetaString_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getMetaString(unsigned long long)
            QString cppResult = cppSelf->getMetaString(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getMetaString_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getOffset(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getOffset";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getOffset()
            unsigned long long cppResult = cppSelf->getOffset();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getOffsetJump(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getOffsetJump";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getOffsetJump(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getOffsetJump(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getOffsetJump_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getOffsetJump(unsigned long long)
            unsigned long long cppResult = cppSelf->getOffsetJump(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getOffsetJump_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getProgramCounterValue(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getProgramCounterValue";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getProgramCounterValue()
            unsigned long long cppResult = cppSelf->getProgramCounterValue();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getRegisterName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getRegisterName";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getRegisterName(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getRegisterName(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getRegisterName_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getRegisterName(QString)
            QString cppResult = cppSelf->getRegisterName(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getRegisterName_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getRegs(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getRegs";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getRegs()
            cppSelf->getRegs();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_getRizinVersionReadable(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getRizinVersionReadable";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths
    if (numArgs > 1) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_getRizinVersionReadable_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|O:getRizinVersionReadable", &(pyArgs[0])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::getRizinVersionReadable(const char*)
    if (numArgs == 0) {
        overloadId = 0; // getRizinVersionReadable(const char*)
    } else if (numArgs >= 1
        && Shiboken::String::check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[0])))) {
        overloadId = 0; // getRizinVersionReadable(const char*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getRizinVersionReadable_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_program = Shiboken::String::createStaticString("program");
            if (PyDict_Contains(kwds, key_program)) {
                value = PyDict_GetItem(kwds, key_program);
                if (value && pyArgs[0]) {
                    errInfo = key_program;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_getRizinVersionReadable_TypeError;
                }
                if (value) {
                    pyArgs[0] = value;
                    if (!Shiboken::String::check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[0]))))
                        goto Sbk_CutterCoreFunc_getRizinVersionReadable_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_program);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_getRizinVersionReadable_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        const char* cppArg0 = nullptr;
        if (pythonToCpp[0]) pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!PyErr_Occurred()) {
            // getRizinVersionReadable(const char*)
            QString cppResult = cppSelf->getRizinVersionReadable(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getRizinVersionReadable_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getSectionList(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getSectionList";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getSectionList()
            QStringList cppResult = cppSelf->getSectionList();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getSeekHistory(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getSeekHistory";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getSeekHistory()
            QList<unsigned long long > cppResult = cppSelf->getSeekHistory();
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_UNSIGNEDLONGLONG_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getString(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getString";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getString(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // getString(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getString_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getString(unsigned long long)
            QString cppResult = cppSelf->getString(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getString_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getTheme(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getTheme";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getTheme()
            QHash<QString,QColor > cppResult = cppSelf->getTheme();
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QHASH_QSTRING_QCOLOR_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getThemeKeys(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getThemeKeys";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getThemeKeys()
            QStringList cppResult = cppSelf->getThemeKeys();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRINGLIST_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_getTypeAsC(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getTypeAsC";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::getTypeAsC(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // getTypeAsC(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_getTypeAsC_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // getTypeAsC(QString)
            QString cppResult = cppSelf->getTypeAsC(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_getTypeAsC_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_getVersionInformation(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.getVersionInformation";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // getVersionInformation()
            QString cppResult = cppSelf->getVersionInformation();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_handleREvent(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.handleREvent";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "handleREvent", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::handleREvent(int,void*)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[1])))) {
        overloadId = 0; // handleREvent(int,void*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_handleREvent_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        void* cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // handleREvent(int,void*)
            cppSelf->handleREvent(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_handleREvent_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_hexStringToBytes(PyObject *self, PyObject *pyArg)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.hexStringToBytes";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static CutterCore::hexStringToBytes(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // hexStringToBytes(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_hexStringToBytes_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // hexStringToBytes(QString)
            QByteArray cppResult = ::CutterCore::hexStringToBytes(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_hexStringToBytes_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_initialize(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.initialize";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths
    if (numArgs > 1) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_initialize_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|O:initialize", &(pyArgs[0])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::initialize(bool)
    if (numArgs == 0) {
        overloadId = 0; // initialize(bool)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0])))) {
        overloadId = 0; // initialize(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_initialize_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_loadPlugins = Shiboken::String::createStaticString("loadPlugins");
            if (PyDict_Contains(kwds, key_loadPlugins)) {
                value = PyDict_GetItem(kwds, key_loadPlugins);
                if (value && pyArgs[0]) {
                    errInfo = key_loadPlugins;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_initialize_TypeError;
                }
                if (value) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0]))))
                        goto Sbk_CutterCoreFunc_initialize_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_loadPlugins);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_initialize_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        bool cppArg0 = true;
        if (pythonToCpp[0]) pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!PyErr_Occurred()) {
            // initialize(bool)
            cppSelf->initialize(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_initialize_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_instance(PyObject *self)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.instance";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // instance()
            CutterCore * cppResult = ::CutterCore::instance();
            pyResult = Shiboken::Conversions::pointerToPython(reinterpret_cast<SbkObjectType *>(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX]), cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_ioRead(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.ioRead";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "ioRead", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::ioRead(unsigned long long,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 0; // ioRead(unsigned long long,int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_ioRead_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // ioRead(unsigned long long,int)
            QByteArray cppResult = cppSelf->ioRead(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QBYTEARRAY_IDX]), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_ioRead_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_isAddressMapped(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isAddressMapped";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::isAddressMapped(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // isAddressMapped(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_isAddressMapped_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // isAddressMapped(unsigned long long)
            bool cppResult = cppSelf->isAddressMapped(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_isAddressMapped_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_isBreakpoint(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isBreakpoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "isBreakpoint", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::isBreakpoint(QList<unsigned long long>,unsigned long long)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_UNSIGNEDLONGLONG_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
        overloadId = 0; // isBreakpoint(QList<unsigned long long>,unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_isBreakpoint_TypeError;

    // Call function/method
    {
        ::QList<unsigned long long > cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // isBreakpoint(QList<unsigned long long>,unsigned long long)
            bool cppResult = cppSelf->isBreakpoint(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_isBreakpoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_isDebugTaskInProgress(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isDebugTaskInProgress";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isDebugTaskInProgress()
            bool cppResult = cppSelf->isDebugTaskInProgress();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_isGraphEmpty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isGraphEmpty";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isGraphEmpty()
            bool cppResult = cppSelf->isGraphEmpty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_isIOCacheEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isIOCacheEnabled";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isIOCacheEnabled()const
            bool cppResult = const_cast<const ::CutterCore *>(cppSelf)->isIOCacheEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_isRedirectableDebugee(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isRedirectableDebugee";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isRedirectableDebugee()
            bool cppResult = cppSelf->isRedirectableDebugee();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_isWriteModeEnabled(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.isWriteModeEnabled";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isWriteModeEnabled()
            bool cppResult = cppSelf->isWriteModeEnabled();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_CutterCoreFunc_itoa(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.itoa";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths
    if (numArgs > 2) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_itoa_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_itoa_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OO:itoa", &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::itoa(unsigned long long,int)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // itoa(unsigned long long,int)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 0; // itoa(unsigned long long,int)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_itoa_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_rdx = Shiboken::String::createStaticString("rdx");
            if (PyDict_Contains(kwds, key_rdx)) {
                value = PyDict_GetItem(kwds, key_rdx);
                if (value && pyArgs[1]) {
                    errInfo = key_rdx;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_itoa_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_itoa_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_rdx);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_itoa_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1 = 16;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // itoa(unsigned long long,int)
            QString cppResult = cppSelf->itoa(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_itoa_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_jmpReverse(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.jmpReverse";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::jmpReverse(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // jmpReverse(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_jmpReverse_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // jmpReverse(unsigned long long)
            cppSelf->jmpReverse(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_jmpReverse_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_listFlagsAsStringAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.listFlagsAsStringAt";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::listFlagsAsStringAt(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // listFlagsAsStringAt(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_listFlagsAsStringAt_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // listFlagsAsStringAt(unsigned long long)
            QString cppResult = cppSelf->listFlagsAsStringAt(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_listFlagsAsStringAt_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_loadCutterRC(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.loadCutterRC";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // loadCutterRC()
            cppSelf->loadCutterRC();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_loadDefaultCutterRC(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.loadDefaultCutterRC";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // loadDefaultCutterRC()
            cppSelf->loadDefaultCutterRC();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_loadFile(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.loadFile";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0, 0, 0, 0, 0};

    // invalid argument lengths
    if (numArgs > 7) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_loadFile_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_loadFile_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OOOOOOO:loadFile", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4]), &(pyArgs[5]), &(pyArgs[6])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[2])))) {
                if (numArgs == 3) {
                    overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
                } else if (numArgs >= 4
                    && (pythonToCpp[3] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3])))) {
                    if (numArgs == 4) {
                        overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
                    } else if (numArgs >= 5
                        && (pythonToCpp[4] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[4])))) {
                        if (numArgs == 5) {
                            overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
                        } else if (numArgs >= 6
                            && (pythonToCpp[5] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[5])))) {
                            if (numArgs == 6) {
                                overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
                            } else if (numArgs >= 7
                                && (pythonToCpp[6] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[6])))) {
                                overloadId = 0; // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
                            }
                        }
                    }
                }
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_loadFile_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_baddr = Shiboken::String::createStaticString("baddr");
            if (PyDict_Contains(kwds, key_baddr)) {
                value = PyDict_GetItem(kwds, key_baddr);
                if (value && pyArgs[1]) {
                    errInfo = key_baddr;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_baddr);
            }
            static PyObject *const key_mapaddr = Shiboken::String::createStaticString("mapaddr");
            if (PyDict_Contains(kwds, key_mapaddr)) {
                value = PyDict_GetItem(kwds, key_mapaddr);
                if (value && pyArgs[2]) {
                    errInfo = key_mapaddr;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                if (value) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[2]))))
                        goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_mapaddr);
            }
            static PyObject *const key_perms = Shiboken::String::createStaticString("perms");
            if (PyDict_Contains(kwds, key_perms)) {
                value = PyDict_GetItem(kwds, key_perms);
                if (value && pyArgs[3]) {
                    errInfo = key_perms;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                if (value) {
                    pyArgs[3] = value;
                    if (!(pythonToCpp[3] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3]))))
                        goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_perms);
            }
            static PyObject *const key_va = Shiboken::String::createStaticString("va");
            if (PyDict_Contains(kwds, key_va)) {
                value = PyDict_GetItem(kwds, key_va);
                if (value && pyArgs[4]) {
                    errInfo = key_va;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                if (value) {
                    pyArgs[4] = value;
                    if (!(pythonToCpp[4] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[4]))))
                        goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_va);
            }
            static PyObject *const key_loadbin = Shiboken::String::createStaticString("loadbin");
            if (PyDict_Contains(kwds, key_loadbin)) {
                value = PyDict_GetItem(kwds, key_loadbin);
                if (value && pyArgs[5]) {
                    errInfo = key_loadbin;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                if (value) {
                    pyArgs[5] = value;
                    if (!(pythonToCpp[5] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[5]))))
                        goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_loadbin);
            }
            static PyObject *const key_forceBinPlugin = Shiboken::String::createStaticString("forceBinPlugin");
            if (PyDict_Contains(kwds, key_forceBinPlugin)) {
                value = PyDict_GetItem(kwds, key_forceBinPlugin);
                if (value && pyArgs[6]) {
                    errInfo = key_forceBinPlugin;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                if (value) {
                    pyArgs[6] = value;
                    if (!(pythonToCpp[6] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[6]))))
                        goto Sbk_CutterCoreFunc_loadFile_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_forceBinPlugin);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_loadFile_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1 = 0LL;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);
        unsigned long long cppArg2 = 0LL;
        if (pythonToCpp[2]) pythonToCpp[2](pyArgs[2], &cppArg2);
        int cppArg3 = RZ_PERM_R;
        if (pythonToCpp[3]) pythonToCpp[3](pyArgs[3], &cppArg3);
        int cppArg4 = 0;
        if (pythonToCpp[4]) pythonToCpp[4](pyArgs[4], &cppArg4);
        bool cppArg5 = false;
        if (pythonToCpp[5]) pythonToCpp[5](pyArgs[5], &cppArg5);
        ::QString cppArg6 = QString();
        if (pythonToCpp[6]) pythonToCpp[6](pyArgs[6], &cppArg6);

        if (!PyErr_Occurred()) {
            // loadFile(QString,unsigned long long,unsigned long long,int,int,bool,QString)
            bool cppResult = cppSelf->loadFile(cppArg0, cppArg1, cppArg2, cppArg3, cppArg4, cppArg5, cppArg6);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_loadFile_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_loadPDB(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.loadPDB";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::loadPDB(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // loadPDB(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_loadPDB_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // loadPDB(QString)
            cppSelf->loadPDB(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_loadPDB_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_loadScript(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.loadScript";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::loadScript(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // loadScript(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_loadScript_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // loadScript(QString)
            cppSelf->loadScript(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_loadScript_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_mapFile(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.mapFile";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "mapFile", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::mapFile(QString,unsigned long long)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
        overloadId = 0; // mapFile(QString,unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_mapFile_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // mapFile(QString,unsigned long long)
            bool cppResult = cppSelf->mapFile(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_mapFile_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_math(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.math";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::math(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // math(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_math_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // math(QString)
            unsigned long long cppResult = cppSelf->math(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_math_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_message(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.message";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths
    if (numArgs > 2) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_message_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_message_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OO:message", &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::message(QString,bool)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // message(QString,bool)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1])))) {
            overloadId = 0; // message(QString,bool)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_message_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_debug = Shiboken::String::createStaticString("debug");
            if (PyDict_Contains(kwds, key_debug)) {
                value = PyDict_GetItem(kwds, key_debug);
                if (value && pyArgs[1]) {
                    errInfo = key_debug;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_message_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_message_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_debug);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_message_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        bool cppArg1 = false;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // message(QString,bool)
            cppSelf->message(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_message_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_nearestFlag(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.nearestFlag";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "nearestFlag", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::nearestFlag(unsigned long long,unsigned long long*)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && PyLong_Check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
        overloadId = 0; // nearestFlag(unsigned long long,unsigned long long*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_nearestFlag_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long *cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // nearestFlag(unsigned long long,unsigned long long*)
            QString cppResult = cppSelf->nearestFlag(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_nearestFlag_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_nextOpAddr(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.nextOpAddr";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "nextOpAddr", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::nextOpAddr(unsigned long long,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 0; // nextOpAddr(unsigned long long,int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_nextOpAddr_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // nextOpAddr(unsigned long long,int)
            unsigned long long cppResult = cppSelf->nextOpAddr(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_nextOpAddr_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_nopInstruction(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.nopInstruction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::nopInstruction(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // nopInstruction(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_nopInstruction_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // nopInstruction(unsigned long long)
            cppSelf->nopInstruction(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_nopInstruction_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_num(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.num";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::num(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // num(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_num_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // num(QString)
            unsigned long long cppResult = cppSelf->num(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_num_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_prevOpAddr(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.prevOpAddr";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "prevOpAddr", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::prevOpAddr(unsigned long long,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 0; // prevOpAddr(unsigned long long,int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_prevOpAddr_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // prevOpAddr(unsigned long long,int)
            unsigned long long cppResult = cppSelf->prevOpAddr(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_prevOpAddr_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_removeString(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.removeString";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::removeString(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // removeString(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_removeString_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // removeString(unsigned long long)
            cppSelf->removeString(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_removeString_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_renameAnalysisMethod(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.renameAnalysisMethod";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "renameAnalysisMethod", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::renameAnalysisMethod(QString,QString,QString)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[2])))) {
        overloadId = 0; // renameAnalysisMethod(QString,QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_renameAnalysisMethod_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        ::QString cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // renameAnalysisMethod(QString,QString,QString)
            cppSelf->renameAnalysisMethod(cppArg0, cppArg1, cppArg2);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_renameAnalysisMethod_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_renameClass(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.renameClass";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "renameClass", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::renameClass(QString,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // renameClass(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_renameClass_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // renameClass(QString,QString)
            cppSelf->renameClass(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_renameClass_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_renameFlag(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.renameFlag";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "renameFlag", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::renameFlag(QString,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // renameFlag(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_renameFlag_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // renameFlag(QString,QString)
            cppSelf->renameFlag(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_renameFlag_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_renameFunction(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.renameFunction";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "renameFunction", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::renameFunction(unsigned long long,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // renameFunction(unsigned long long,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_renameFunction_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // renameFunction(unsigned long long,QString)
            cppSelf->renameFunction(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_renameFunction_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_renameFunctionVariable(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.renameFunctionVariable";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "renameFunctionVariable", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::renameFunctionVariable(QString,QString,unsigned long long)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[2])))) {
        overloadId = 0; // renameFunctionVariable(QString,QString,unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_renameFunctionVariable_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        unsigned long long cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // renameFunctionVariable(QString,QString,unsigned long long)
            cppSelf->renameFunctionVariable(cppArg0, cppArg1, cppArg2);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_renameFunctionVariable_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_resetWriteCache(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.resetWriteCache";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // resetWriteCache()
            cppSelf->resetWriteCache();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_sanitizeStringForCommand(PyObject *self, PyObject *pyArg)
{
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.sanitizeStringForCommand";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static CutterCore::sanitizeStringForCommand(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // sanitizeStringForCommand(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_sanitizeStringForCommand_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // sanitizeStringForCommand(QString)
            QString cppResult = ::CutterCore::sanitizeStringForCommand(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_sanitizeStringForCommand_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_sdbGet(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.sdbGet";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "sdbGet", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::sdbGet(QString,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // sdbGet(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_sdbGet_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // sdbGet(QString,QString)
            QString cppResult = cppSelf->sdbGet(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_sdbGet_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_sdbList(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.sdbList";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::sdbList(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // sdbList(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_sdbList_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // sdbList(QString)
            QList<QString > cppResult = cppSelf->sdbList(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_sdbList_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_sdbListKeys(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.sdbListKeys";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::sdbListKeys(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // sdbListKeys(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_sdbListKeys_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // sdbListKeys(QString)
            QList<QString > cppResult = cppSelf->sdbListKeys(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_sdbListKeys_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_sdbSet(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.sdbSet";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "sdbSet", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::sdbSet(QString,QString,QString)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[2])))) {
        overloadId = 0; // sdbSet(QString,QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_sdbSet_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        ::QString cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // sdbSet(QString,QString,QString)
            bool cppResult = cppSelf->sdbSet(cppArg0, cppArg1, cppArg2);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_sdbSet_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_seek(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.seek";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::seek(QString)
    // 1: CutterCore::seek(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 1; // seek(unsigned long long)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // seek(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_seek_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // seek(QString thing)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // seek(QString)
                cppSelf->seek(cppArg0);
            }
            break;
        }
        case 1: // seek(unsigned long long offset)
        {
            unsigned long long cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // seek(unsigned long long)
                cppSelf->seek(cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_seek_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_seekAndShow(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.seekAndShow";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::seekAndShow(QString)
    // 1: CutterCore::seekAndShow(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 1; // seekAndShow(unsigned long long)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // seekAndShow(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_seekAndShow_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // seekAndShow(QString thing)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // seekAndShow(QString)
                cppSelf->seekAndShow(cppArg0);
            }
            break;
        }
        case 1: // seekAndShow(unsigned long long offset)
        {
            unsigned long long cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // seekAndShow(unsigned long long)
                cppSelf->seekAndShow(cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_seekAndShow_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_seekNext(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.seekNext";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // seekNext()
            cppSelf->seekNext();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_seekPrev(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.seekPrev";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // seekPrev()
            cppSelf->seekPrev();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_seekSilent(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.seekSilent";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::seekSilent(QString)
    // 1: CutterCore::seekSilent(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 1; // seekSilent(unsigned long long)
    } else if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // seekSilent(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_seekSilent_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // seekSilent(QString thing)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // seekSilent(QString)
                cppSelf->seekSilent(cppArg0);
            }
            break;
        }
        case 1: // seekSilent(unsigned long long offset)
        {
            unsigned long long cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (!PyErr_Occurred()) {
                // seekSilent(unsigned long long)
                cppSelf->seekSilent(cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_seekSilent_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setAsString(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setAsString";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths
    if (numArgs > 2) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setAsString_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setAsString_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OO:setAsString", &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setAsString(unsigned long long,int)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // setAsString(unsigned long long,int)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 0; // setAsString(unsigned long long,int)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setAsString_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_size = Shiboken::String::createStaticString("size");
            if (PyDict_Contains(kwds, key_size)) {
                value = PyDict_GetItem(kwds, key_size);
                if (value && pyArgs[1]) {
                    errInfo = key_size;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_setAsString_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_setAsString_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_size);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_setAsString_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1 = 0;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setAsString(unsigned long long,int)
            cppSelf->setAsString(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setAsString_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setBreakpointTrace(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setBreakpointTrace";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setBreakpointTrace", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setBreakpointTrace(int,bool)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1])))) {
        overloadId = 0; // setBreakpointTrace(int,bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setBreakpointTrace_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        bool cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setBreakpointTrace(int,bool)
            cppSelf->setBreakpointTrace(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setBreakpointTrace_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setCPU(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setCPU";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setCPU", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setCPU(QString,QString,int)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
        overloadId = 0; // setCPU(QString,QString,int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setCPU_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        int cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // setCPU(QString,QString,int)
            cppSelf->setCPU(cppArg0, cppArg1, cppArg2);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setCPU_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setColor(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setColor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setColor", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setColor(QString,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // setColor(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setColor_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setColor(QString,QString)
            bool cppResult = cppSelf->setColor(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_setColor_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setComment(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setComment";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setComment", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setComment(unsigned long long,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // setComment(unsigned long long,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setComment_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setComment(unsigned long long,QString)
            cppSelf->setComment(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setComment_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setConfig(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setConfig";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setConfig", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setConfig(QString,bool)
    // 1: CutterCore::setConfig(QString,QString)
    // 2: CutterCore::setConfig(QString,QVariant)
    // 3: CutterCore::setConfig(QString,const char*)
    // 4: CutterCore::setConfig(QString,int)
    // 5: CutterCore::setConfig(const char*,bool)
    // 6: CutterCore::setConfig(const char*,QString)
    // 7: CutterCore::setConfig(const char*,QVariant)
    // 8: CutterCore::setConfig(const char*,const char*)
    // 9: CutterCore::setConfig(const char*,int)
    if (numArgs >= 1
        && Shiboken::String::check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[0])))) {
        if (numArgs == 2
            && Shiboken::String::check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[1])))) {
            overloadId = 8; // setConfig(const char*,const char*)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
            overloadId = 6; // setConfig(const char*,QString)
        } else if (numArgs == 2
            && PyBool_Check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1])))) {
            overloadId = 5; // setConfig(const char*,bool)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 9; // setConfig(const char*,int)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QVARIANT_IDX], (pyArgs[1])))) {
            overloadId = 7; // setConfig(const char*,QVariant)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))) {
        if (numArgs == 2
            && Shiboken::String::check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[1])))) {
            overloadId = 3; // setConfig(QString,const char*)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
            overloadId = 1; // setConfig(QString,QString)
        } else if (numArgs == 2
            && PyBool_Check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1])))) {
            overloadId = 0; // setConfig(QString,bool)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 4; // setConfig(QString,int)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QVARIANT_IDX], (pyArgs[1])))) {
            overloadId = 2; // setConfig(QString,QVariant)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setConfig_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // setConfig(const QString & k, bool v)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            bool cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(QString,bool)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 1: // setConfig(const QString & k, const QString & v)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(QString,QString)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // setConfig(const QString & k, const QVariant & v)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QVariant cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(QString,QVariant)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 3: // setConfig(const QString & k, const char * v)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            const char* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(QString,const char*)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 4: // setConfig(const QString & k, int v)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(QString,int)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 5: // setConfig(const char * k, bool v)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            bool cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(const char*,bool)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 6: // setConfig(const char * k, const QString & v)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(const char*,QString)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 7: // setConfig(const char * k, const QVariant & v)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QVariant cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(const char*,QVariant)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 8: // setConfig(const char * k, const char * v)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            const char* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(const char*,const char*)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
        case 9: // setConfig(const char * k, int v)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setConfig(const char*,int)
                cppSelf->setConfig(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setConfig_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setCurrentBits(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setCurrentBits";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths
    if (numArgs > 2) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setCurrentBits_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setCurrentBits_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OO:setCurrentBits", &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setCurrentBits(int,unsigned long long)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // setCurrentBits(int,unsigned long long)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
            overloadId = 0; // setCurrentBits(int,unsigned long long)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setCurrentBits_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_offset = Shiboken::String::createStaticString("offset");
            if (PyDict_Contains(kwds, key_offset)) {
                value = PyDict_GetItem(kwds, key_offset);
                if (value && pyArgs[1]) {
                    errInfo = key_offset;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_setCurrentBits_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_setCurrentBits_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_offset);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_setCurrentBits_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1 = RVA_INVALID;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setCurrentBits(int,unsigned long long)
            cppSelf->setCurrentBits(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setCurrentBits_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setCurrentDebugProcess(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setCurrentDebugProcess";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setCurrentDebugProcess(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setCurrentDebugProcess(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setCurrentDebugProcess_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setCurrentDebugProcess(int)
            cppSelf->setCurrentDebugProcess(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setCurrentDebugProcess_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setCurrentDebugThread(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setCurrentDebugThread";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setCurrentDebugThread(int)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setCurrentDebugThread(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setCurrentDebugThread_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setCurrentDebugThread(int)
            cppSelf->setCurrentDebugThread(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setCurrentDebugThread_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setDebugPlugin(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setDebugPlugin";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setDebugPlugin(QString)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setDebugPlugin(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setDebugPlugin_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setDebugPlugin(QString)
            cppSelf->setDebugPlugin(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setDebugPlugin_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setEndianness(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setEndianness";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setEndianness(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setEndianness(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setEndianness_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setEndianness(bool)
            cppSelf->setEndianness(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setEndianness_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setGraphEmpty(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setGraphEmpty";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setGraphEmpty(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setGraphEmpty(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setGraphEmpty_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setGraphEmpty(bool)
            cppSelf->setGraphEmpty(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setGraphEmpty_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setIOCache(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setIOCache";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setIOCache(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setIOCache(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setIOCache_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setIOCache(bool)
            cppSelf->setIOCache(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setIOCache_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setImmediateBase(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setImmediateBase";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths
    if (numArgs > 2) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setImmediateBase_TypeError;
    } else if (numArgs < 1) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setImmediateBase_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OO:setImmediateBase", &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setImmediateBase(QString,unsigned long long)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // setImmediateBase(QString,unsigned long long)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
            overloadId = 0; // setImmediateBase(QString,unsigned long long)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setImmediateBase_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_offset = Shiboken::String::createStaticString("offset");
            if (PyDict_Contains(kwds, key_offset)) {
                value = PyDict_GetItem(kwds, key_offset);
                if (value && pyArgs[1]) {
                    errInfo = key_offset;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_setImmediateBase_TypeError;
                }
                if (value) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1]))))
                        goto Sbk_CutterCoreFunc_setImmediateBase_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_offset);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_setImmediateBase_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1 = RVA_INVALID;
        if (pythonToCpp[1]) pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setImmediateBase(QString,unsigned long long)
            cppSelf->setImmediateBase(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setImmediateBase_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setRegister(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setRegister";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setRegister", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setRegister(QString,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // setRegister(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setRegister_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // setRegister(QString,QString)
            cppSelf->setRegister(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setRegister_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setSettings(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setSettings";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // setSettings()
            cppSelf->setSettings();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_setToCode(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setToCode";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setToCode(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // setToCode(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setToCode_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setToCode(unsigned long long)
            cppSelf->setToCode(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setToCode_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setToData(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setToData";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths
    if (numArgs > 3) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo = too_many;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setToData_TypeError;
    } else if (numArgs < 2) {
        static PyObject *const too_few = Shiboken::String::createStaticString("<");
        errInfo = too_few;
        Py_INCREF(errInfo);
        goto Sbk_CutterCoreFunc_setToData_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|OOO:setToData", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::setToData(unsigned long long,int,int)
    if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 0; // setToData(unsigned long long,int,int)
        } else if (numArgs >= 3
            && (pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
            overloadId = 0; // setToData(unsigned long long,int,int)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setToData_TypeError;

    // Call function/method
    {
        if (kwds) {
            PyObject *value{};
            PyObject *kwds_dup = PyDict_Copy(kwds);
            static PyObject *const key_repeat = Shiboken::String::createStaticString("repeat");
            if (PyDict_Contains(kwds, key_repeat)) {
                value = PyDict_GetItem(kwds, key_repeat);
                if (value && pyArgs[2]) {
                    errInfo = key_repeat;
                    Py_INCREF(errInfo);
                    goto Sbk_CutterCoreFunc_setToData_TypeError;
                }
                if (value) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2]))))
                        goto Sbk_CutterCoreFunc_setToData_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_repeat);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo = kwds_dup;
                goto Sbk_CutterCoreFunc_setToData_TypeError;
            } else {
                Py_DECREF(kwds_dup);
            }
        }
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        int cppArg2 = 1;
        if (pythonToCpp[2]) pythonToCpp[2](pyArgs[2], &cppArg2);

        if (!PyErr_Occurred()) {
            // setToData(unsigned long long,int,int)
            cppSelf->setToData(cppArg0, cppArg1, cppArg2);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setToData_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_setWriteMode(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.setWriteMode";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::setWriteMode(bool)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setWriteMode(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_setWriteMode_TypeError;

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setWriteMode(bool)
            cppSelf->setWriteMode(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_setWriteMode_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_showMemoryWidget(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.showMemoryWidget";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // showMemoryWidget()
            cppSelf->showMemoryWidget();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_sizeofDataMeta(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.sizeofDataMeta";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::sizeofDataMeta(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // sizeofDataMeta(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_sizeofDataMeta_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // sizeofDataMeta(unsigned long long)
            int cppResult = cppSelf->sizeofDataMeta(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_sizeofDataMeta_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_startDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.startDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // startDebug()
            cppSelf->startDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_startEmulation(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.startEmulation";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // startEmulation()
            cppSelf->startEmulation();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_startTraceSession(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.startTraceSession";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // startTraceSession()
            cppSelf->startTraceSession();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_stepBackDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.stepBackDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stepBackDebug()
            cppSelf->stepBackDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_stepDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.stepDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stepDebug()
            cppSelf->stepDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_stepOutDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.stepOutDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stepOutDebug()
            cppSelf->stepOutDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_stepOverDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.stepOverDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stepOverDebug()
            cppSelf->stepOverDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_stopDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.stopDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stopDebug()
            cppSelf->stopDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_stopTraceSession(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.stopTraceSession";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stopTraceSession()
            cppSelf->stopTraceSession();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_suspendDebug(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.suspendDebug";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // suspendDebug()
            cppSelf->suspendDebug();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_syncAndSeekProgramCounter(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.syncAndSeekProgramCounter";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // syncAndSeekProgramCounter()
            cppSelf->syncAndSeekProgramCounter();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_toggleBreakpoint(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.toggleBreakpoint";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp{};
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: CutterCore::toggleBreakpoint(unsigned long long)
    if ((pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArg)))) {
        overloadId = 0; // toggleBreakpoint(unsigned long long)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_toggleBreakpoint_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // toggleBreakpoint(unsigned long long)
            cppSelf->toggleBreakpoint(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_toggleBreakpoint_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_triggerAsmOptionsChanged(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.triggerAsmOptionsChanged";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // triggerAsmOptionsChanged()
            cppSelf->triggerAsmOptionsChanged();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_triggerFlagsChanged(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.triggerFlagsChanged";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // triggerFlagsChanged()
            cppSelf->triggerFlagsChanged();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_triggerFunctionRenamed(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.triggerFunctionRenamed";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "triggerFunctionRenamed", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::triggerFunctionRenamed(unsigned long long,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[1])))) {
        overloadId = 0; // triggerFunctionRenamed(unsigned long long,QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_triggerFunctionRenamed_TypeError;

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // triggerFunctionRenamed(unsigned long long,QString)
            cppSelf->triggerFunctionRenamed(cppArg0, cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_CutterCoreFunc_triggerFunctionRenamed_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_triggerGraphOptionsChanged(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.triggerGraphOptionsChanged";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // triggerGraphOptionsChanged()
            cppSelf->triggerGraphOptionsChanged();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_triggerRefreshAll(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.triggerRefreshAll";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // triggerRefreshAll()
            cppSelf->triggerRefreshAll();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_triggerVarsChanged(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.triggerVarsChanged";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // triggerVarsChanged()
            cppSelf->triggerVarsChanged();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_CutterCoreFunc_tryFile(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.tryFile";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { nullptr, nullptr };
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "tryFile", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: CutterCore::tryFile(QString,bool)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1])))) {
        overloadId = 0; // tryFile(QString,bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_CutterCoreFunc_tryFile_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        bool cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!PyErr_Occurred()) {
            // tryFile(QString,bool)
            bool cppResult = cppSelf->tryFile(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_CutterCoreFunc_tryFile_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        Py_XDECREF(errInfo);
        return {};
}

static PyObject *Sbk_CutterCoreFunc_updateSeek(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *errInfo{};
    SBK_UNUSED(errInfo)
    static const char *fullName = "CutterBindings.CutterCore.updateSeek";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // updateSeek()
            cppSelf->updateSeek();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_CutterCore_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_CutterCore_methods[] = {
    {"addFlag", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_addFlag), METH_VARARGS},
    {"ansiEscapeToHtml", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_ansiEscapeToHtml), METH_O|METH_STATIC},
    {"applySignature", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_applySignature), METH_O},
    {"applyStructureOffset", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_applyStructureOffset), METH_VARARGS|METH_KEYWORDS},
    {"assemble", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_assemble), METH_O},
    {"attachDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_attachDebug), METH_O},
    {"attachRemote", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_attachRemote), METH_O},
    {"breakpointIndexAt", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_breakpointIndexAt), METH_O},
    {"bytesToHexString", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_bytesToHexString), METH_O|METH_STATIC},
    {"cmd", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_cmd), METH_O},
    {"cmdRaw", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_cmdRaw), METH_O},
    {"cmdRawAt", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_cmdRawAt), METH_VARARGS},
    {"cmdTask", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_cmdTask), METH_O},
    {"commitWriteCache", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_commitWriteCache), METH_NOARGS},
    {"continueBackDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_continueBackDebug), METH_NOARGS},
    {"continueDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_continueDebug), METH_NOARGS},
    {"continueUntilCall", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_continueUntilCall), METH_NOARGS},
    {"continueUntilDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_continueUntilDebug), METH_O},
    {"continueUntilSyscall", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_continueUntilSyscall), METH_NOARGS},
    {"createFunctionAt", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_createFunctionAt), METH_VARARGS},
    {"createNewClass", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_createNewClass), METH_O},
    {"createSignature", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_createSignature), METH_O},
    {"delAllBreakpoints", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_delAllBreakpoints), METH_NOARGS},
    {"delBreakpoint", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_delBreakpoint), METH_O},
    {"delComment", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_delComment), METH_O},
    {"delFlag", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_delFlag), METH_O},
    {"delFunction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_delFunction), METH_O},
    {"deleteClass", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_deleteClass), METH_O},
    {"disableBreakpoint", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_disableBreakpoint), METH_O},
    {"disassemble", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_disassemble), METH_O},
    {"disassembleSingleInstruction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_disassembleSingleInstruction), METH_O},
    {"editBytes", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_editBytes), METH_VARARGS},
    {"editBytesEndian", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_editBytesEndian), METH_VARARGS},
    {"editInstruction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_editInstruction), METH_VARARGS|METH_KEYWORDS},
    {"enableBreakpoint", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_enableBreakpoint), METH_O},
    {"existsFileInfo", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_existsFileInfo), METH_NOARGS},
    {"flagAt", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_flagAt), METH_O},
    {"getActiveDebugPlugin", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getActiveDebugPlugin), METH_NOARGS},
    {"getAllAnalysisClasses", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getAllAnalysisClasses), METH_O},
    {"getAnalysisPluginNames", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getAnalysisPluginNames), METH_NOARGS},
    {"getArchBits", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getArchBits), METH_NOARGS},
    {"getAsmPluginNames", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getAsmPluginNames), METH_NOARGS},
    {"getBBHighlighter", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getBBHighlighter), METH_NOARGS},
    {"getBreakpointsAddresses", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getBreakpointsAddresses), METH_NOARGS},
    {"getBreakpointsInFunction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getBreakpointsInFunction), METH_O},
    {"getColorThemes", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getColorThemes), METH_NOARGS},
    {"getCommentAt", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getCommentAt), METH_O},
    {"getConfig", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfig), METH_O},
    {"getConfigDescription", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfigDescription), METH_O},
    {"getConfigOptions", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfigOptions), METH_O},
    {"getConfigVariableSpaces", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfigVariableSpaces), METH_VARARGS|METH_KEYWORDS},
    {"getConfigb", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfigb), METH_O},
    {"getConfigi", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfigi), METH_O},
    {"getConfigut64", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getConfigut64), METH_O},
    {"getCutterRCDefaultDirectory", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getCutterRCDefaultDirectory), METH_NOARGS},
    {"getDebugPlugins", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getDebugPlugins), METH_NOARGS},
    {"getDisassemblyPreview", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getDisassemblyPreview), METH_VARARGS},
    {"getFunctionEnd", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getFunctionEnd), METH_O},
    {"getFunctionStart", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getFunctionStart), METH_O},
    {"getHexdumpPreview", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getHexdumpPreview), METH_VARARGS},
    {"getInstructionBytes", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getInstructionBytes), METH_O},
    {"getInstructionOpcode", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getInstructionOpcode), METH_O},
    {"getLastFunctionInstruction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getLastFunctionInstruction), METH_O},
    {"getMetaString", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getMetaString), METH_O},
    {"getOffset", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getOffset), METH_NOARGS},
    {"getOffsetJump", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getOffsetJump), METH_O},
    {"getProgramCounterValue", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getProgramCounterValue), METH_NOARGS},
    {"getRegisterName", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getRegisterName), METH_O},
    {"getRegs", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getRegs), METH_NOARGS},
    {"getRizinVersionReadable", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getRizinVersionReadable), METH_VARARGS|METH_KEYWORDS},
    {"getSectionList", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getSectionList), METH_NOARGS},
    {"getSeekHistory", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getSeekHistory), METH_NOARGS},
    {"getString", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getString), METH_O},
    {"getTheme", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getTheme), METH_NOARGS},
    {"getThemeKeys", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getThemeKeys), METH_NOARGS},
    {"getTypeAsC", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getTypeAsC), METH_O},
    {"getVersionInformation", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_getVersionInformation), METH_NOARGS},
    {"handleREvent", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_handleREvent), METH_VARARGS},
    {"hexStringToBytes", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_hexStringToBytes), METH_O|METH_STATIC},
    {"initialize", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_initialize), METH_VARARGS|METH_KEYWORDS},
    {"instance", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_instance), METH_NOARGS|METH_STATIC},
    {"ioRead", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_ioRead), METH_VARARGS},
    {"isAddressMapped", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isAddressMapped), METH_O},
    {"isBreakpoint", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isBreakpoint), METH_VARARGS},
    {"isDebugTaskInProgress", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isDebugTaskInProgress), METH_NOARGS},
    {"isGraphEmpty", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isGraphEmpty), METH_NOARGS},
    {"isIOCacheEnabled", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isIOCacheEnabled), METH_NOARGS},
    {"isRedirectableDebugee", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isRedirectableDebugee), METH_NOARGS},
    {"isWriteModeEnabled", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_isWriteModeEnabled), METH_NOARGS},
    {"itoa", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_itoa), METH_VARARGS|METH_KEYWORDS},
    {"jmpReverse", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_jmpReverse), METH_O},
    {"listFlagsAsStringAt", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_listFlagsAsStringAt), METH_O},
    {"loadCutterRC", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_loadCutterRC), METH_NOARGS},
    {"loadDefaultCutterRC", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_loadDefaultCutterRC), METH_NOARGS},
    {"loadFile", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_loadFile), METH_VARARGS|METH_KEYWORDS},
    {"loadPDB", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_loadPDB), METH_O},
    {"loadScript", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_loadScript), METH_O},
    {"mapFile", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_mapFile), METH_VARARGS},
    {"math", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_math), METH_O},
    {"message", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_message), METH_VARARGS|METH_KEYWORDS},
    {"nearestFlag", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_nearestFlag), METH_VARARGS},
    {"nextOpAddr", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_nextOpAddr), METH_VARARGS},
    {"nopInstruction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_nopInstruction), METH_O},
    {"num", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_num), METH_O},
    {"prevOpAddr", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_prevOpAddr), METH_VARARGS},
    {"removeString", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_removeString), METH_O},
    {"renameAnalysisMethod", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_renameAnalysisMethod), METH_VARARGS},
    {"renameClass", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_renameClass), METH_VARARGS},
    {"renameFlag", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_renameFlag), METH_VARARGS},
    {"renameFunction", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_renameFunction), METH_VARARGS},
    {"renameFunctionVariable", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_renameFunctionVariable), METH_VARARGS},
    {"resetWriteCache", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_resetWriteCache), METH_NOARGS},
    {"sanitizeStringForCommand", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_sanitizeStringForCommand), METH_O|METH_STATIC},
    {"sdbGet", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_sdbGet), METH_VARARGS},
    {"sdbList", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_sdbList), METH_O},
    {"sdbListKeys", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_sdbListKeys), METH_O},
    {"sdbSet", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_sdbSet), METH_VARARGS},
    {"seek", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_seek), METH_O},
    {"seekAndShow", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_seekAndShow), METH_O},
    {"seekNext", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_seekNext), METH_NOARGS},
    {"seekPrev", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_seekPrev), METH_NOARGS},
    {"seekSilent", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_seekSilent), METH_O},
    {"setAsString", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setAsString), METH_VARARGS|METH_KEYWORDS},
    {"setBreakpointTrace", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setBreakpointTrace), METH_VARARGS},
    {"setCPU", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setCPU), METH_VARARGS},
    {"setColor", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setColor), METH_VARARGS},
    {"setComment", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setComment), METH_VARARGS},
    {"setConfig", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setConfig), METH_VARARGS},
    {"setCurrentBits", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setCurrentBits), METH_VARARGS|METH_KEYWORDS},
    {"setCurrentDebugProcess", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setCurrentDebugProcess), METH_O},
    {"setCurrentDebugThread", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setCurrentDebugThread), METH_O},
    {"setDebugPlugin", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setDebugPlugin), METH_O},
    {"setEndianness", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setEndianness), METH_O},
    {"setGraphEmpty", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setGraphEmpty), METH_O},
    {"setIOCache", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setIOCache), METH_O},
    {"setImmediateBase", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setImmediateBase), METH_VARARGS|METH_KEYWORDS},
    {"setRegister", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setRegister), METH_VARARGS},
    {"setSettings", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setSettings), METH_NOARGS},
    {"setToCode", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setToCode), METH_O},
    {"setToData", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setToData), METH_VARARGS|METH_KEYWORDS},
    {"setWriteMode", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_setWriteMode), METH_O},
    {"showMemoryWidget", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_showMemoryWidget), METH_NOARGS},
    {"sizeofDataMeta", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_sizeofDataMeta), METH_O},
    {"startDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_startDebug), METH_NOARGS},
    {"startEmulation", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_startEmulation), METH_NOARGS},
    {"startTraceSession", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_startTraceSession), METH_NOARGS},
    {"stepBackDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_stepBackDebug), METH_NOARGS},
    {"stepDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_stepDebug), METH_NOARGS},
    {"stepOutDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_stepOutDebug), METH_NOARGS},
    {"stepOverDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_stepOverDebug), METH_NOARGS},
    {"stopDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_stopDebug), METH_NOARGS},
    {"stopTraceSession", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_stopTraceSession), METH_NOARGS},
    {"suspendDebug", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_suspendDebug), METH_NOARGS},
    {"syncAndSeekProgramCounter", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_syncAndSeekProgramCounter), METH_NOARGS},
    {"toggleBreakpoint", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_toggleBreakpoint), METH_O},
    {"triggerAsmOptionsChanged", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_triggerAsmOptionsChanged), METH_NOARGS},
    {"triggerFlagsChanged", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_triggerFlagsChanged), METH_NOARGS},
    {"triggerFunctionRenamed", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_triggerFunctionRenamed), METH_VARARGS},
    {"triggerGraphOptionsChanged", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_triggerGraphOptionsChanged), METH_NOARGS},
    {"triggerRefreshAll", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_triggerRefreshAll), METH_NOARGS},
    {"triggerVarsChanged", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_triggerVarsChanged), METH_NOARGS},
    {"tryFile", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_tryFile), METH_VARARGS},
    {"updateSeek", reinterpret_cast<PyCFunction>(Sbk_CutterCoreFunc_updateSeek), METH_NOARGS},

    {nullptr, nullptr} // Sentinel
};

static int Sbk_CutterCore_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value && PyCallable_Check(value)) {
        auto plain_inst = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
        auto inst = dynamic_cast<CutterCoreWrapper *>(plain_inst);
        if (inst)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

static PyObject *Sbk_CutterCore_get_currentlyDebugging(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->currentlyDebugging;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_CutterCore_set_currentlyDebugging(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'currentlyDebugging' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'currentlyDebugging', 'bool' or convertible type expected");
        return -1;
    }

    bool cppOut_local = cppSelf->currentlyDebugging;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->currentlyDebugging = cppOut_local;

    return 0;
}

static PyObject *Sbk_CutterCore_get_currentlyEmulating(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->currentlyEmulating;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_CutterCore_set_currentlyEmulating(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'currentlyEmulating' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'currentlyEmulating', 'bool' or convertible type expected");
        return -1;
    }

    bool cppOut_local = cppSelf->currentlyEmulating;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->currentlyEmulating = cppOut_local;

    return 0;
}

static PyObject *Sbk_CutterCore_get_currentlyTracing(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->currentlyTracing;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_CutterCore_set_currentlyTracing(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'currentlyTracing' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'currentlyTracing', 'bool' or convertible type expected");
        return -1;
    }

    bool cppOut_local = cppSelf->currentlyTracing;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->currentlyTracing = cppOut_local;

    return 0;
}

static PyObject *Sbk_CutterCore_get_currentlyRemoteDebugging(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->currentlyRemoteDebugging;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_CutterCore_set_currentlyRemoteDebugging(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'currentlyRemoteDebugging' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'currentlyRemoteDebugging', 'bool' or convertible type expected");
        return -1;
    }

    bool cppOut_local = cppSelf->currentlyRemoteDebugging;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->currentlyRemoteDebugging = cppOut_local;

    return 0;
}

static PyObject *Sbk_CutterCore_get_currentlyAttachedToPID(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->currentlyAttachedToPID;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_CutterCore_set_currentlyAttachedToPID(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'currentlyAttachedToPID' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'currentlyAttachedToPID', 'int' or convertible type expected");
        return -1;
    }

    int cppOut_local = cppSelf->currentlyAttachedToPID;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->currentlyAttachedToPID = cppOut_local;

    return 0;
}

static PyObject *Sbk_CutterCore_get_currentlyOpenFile(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppSelf->currentlyOpenFile);
    return pyOut;
}
static int Sbk_CutterCore_set_currentlyOpenFile(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'currentlyOpenFile' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkPySide2_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'currentlyOpenFile', 'QString' or convertible type expected");
        return -1;
    }

    ::QString& cppOut_ptr = cppSelf->currentlyOpenFile;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_CutterCore_get_regs(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX], &cppSelf->regs);
    return pyOut;
}
static int Sbk_CutterCore_set_regs(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::CutterCore *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'regs' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp{nullptr};
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppConvertible(SbkCutterBindingsTypeConverters[SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'regs', 'QList' or convertible type expected");
        return -1;
    }

    ::QList<QString >& cppOut_ptr = cppSelf->regs;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for CutterCore
static PyGetSetDef Sbk_CutterCore_getsetlist[] = {
    {const_cast<char *>("currentlyDebugging"), Sbk_CutterCore_get_currentlyDebugging, Sbk_CutterCore_set_currentlyDebugging},
    {const_cast<char *>("currentlyEmulating"), Sbk_CutterCore_get_currentlyEmulating, Sbk_CutterCore_set_currentlyEmulating},
    {const_cast<char *>("currentlyTracing"), Sbk_CutterCore_get_currentlyTracing, Sbk_CutterCore_set_currentlyTracing},
    {const_cast<char *>("currentlyRemoteDebugging"), Sbk_CutterCore_get_currentlyRemoteDebugging, Sbk_CutterCore_set_currentlyRemoteDebugging},
    {const_cast<char *>("currentlyAttachedToPID"), Sbk_CutterCore_get_currentlyAttachedToPID, Sbk_CutterCore_set_currentlyAttachedToPID},
    {const_cast<char *>("currentlyOpenFile"), Sbk_CutterCore_get_currentlyOpenFile, Sbk_CutterCore_set_currentlyOpenFile},
    {const_cast<char *>("regs"), Sbk_CutterCore_get_regs, Sbk_CutterCore_set_regs},
    {nullptr} // Sentinel
};

} // extern "C"

static int Sbk_CutterCore_traverse(PyObject *self, visitproc visit, void *arg)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_traverse(self, visit, arg);
}
static int Sbk_CutterCore_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType *_Sbk_CutterCore_Type = nullptr;
static SbkObjectType *Sbk_CutterCore_TypeF(void)
{
    return _Sbk_CutterCore_Type;
}

static PyType_Slot Sbk_CutterCore_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_CutterCore_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_CutterCore_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_CutterCore_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_CutterCore_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_CutterCore_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_CutterCore_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_CutterCore_spec = {
    "1:CutterBindings.CutterCore",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    Sbk_CutterCore_slots
};

} //extern "C"

static void *Sbk_CutterCore_typeDiscovery(void *cptr, SbkObjectType *instanceType)
{
    if (instanceType == reinterpret_cast<SbkObjectType *>(Shiboken::SbkType< ::QObject >()))
        return dynamic_cast< ::CutterCore *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void CutterCore_PythonToCpp_CutterCore_PTR(PyObject *pyIn, void *cppOut) {
    Shiboken::Conversions::pythonToCppPointer(Sbk_CutterCore_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_CutterCore_PythonToCpp_CutterCore_PTR_Convertible(PyObject *pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_CutterCore_TypeF())))
        return CutterCore_PythonToCpp_CutterCore_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *CutterCore_PTR_CppToPython_CutterCore(const void *cppIn) {
    return PySide::getWrapperForQObject(reinterpret_cast<::CutterCore *>(const_cast<void *>(cppIn)), Sbk_CutterCore_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *CutterCore_SignatureStrings[] = {
    "CutterBindings.CutterCore(self,parent:PySide2.QtCore.QObject=nullptr)",
    "CutterBindings.CutterCore.addFlag(self,offset:unsigned long long,name:QString,size:unsigned long long)",
    "CutterBindings.CutterCore.ansiEscapeToHtml(text:QString)->QString",
    "CutterBindings.CutterCore.applySignature(self,filepath:QString)",
    "CutterBindings.CutterCore.applyStructureOffset(self,structureOffset:QString,offset:unsigned long long=RVA_INVALID)",
    "CutterBindings.CutterCore.assemble(self,code:QString)->PySide2.QtCore.QByteArray",
    "CutterBindings.CutterCore.attachDebug(self,pid:int)",
    "CutterBindings.CutterCore.attachRemote(self,uri:QString)",
    "CutterBindings.CutterCore.breakpointIndexAt(self,addr:unsigned long long)->int",
    "CutterBindings.CutterCore.bytesToHexString(bytes:PySide2.QtCore.QByteArray)->QString",
    "1:CutterBindings.CutterCore.cmd(self,str:QString)->QString",
    "0:CutterBindings.CutterCore.cmd(self,str:char*)->QString",
    "1:CutterBindings.CutterCore.cmdRaw(self,cmd:QString)->QString",
    "0:CutterBindings.CutterCore.cmdRaw(self,cmd:char*)->QString",
    "1:CutterBindings.CutterCore.cmdRawAt(self,str:QString,address:unsigned long long)->QString",
    "0:CutterBindings.CutterCore.cmdRawAt(self,cmd:char*,address:unsigned long long)->QString",
    "CutterBindings.CutterCore.cmdTask(self,str:QString)->QString",
    "CutterBindings.CutterCore.commitWriteCache(self)",
    "CutterBindings.CutterCore.continueBackDebug(self)",
    "CutterBindings.CutterCore.continueDebug(self)",
    "CutterBindings.CutterCore.continueUntilCall(self)",
    "CutterBindings.CutterCore.continueUntilDebug(self,offset:unsigned long long)",
    "CutterBindings.CutterCore.continueUntilSyscall(self)",
    "1:CutterBindings.CutterCore.createFunctionAt(self,addr:unsigned long long)",
    "0:CutterBindings.CutterCore.createFunctionAt(self,addr:unsigned long long,name:QString)",
    "CutterBindings.CutterCore.createNewClass(self,cls:QString)",
    "CutterBindings.CutterCore.createSignature(self,filepath:QString)",
    "CutterBindings.CutterCore.delAllBreakpoints(self)",
    "CutterBindings.CutterCore.delBreakpoint(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.delComment(self,addr:unsigned long long)",
    "1:CutterBindings.CutterCore.delFlag(self,name:QString)",
    "0:CutterBindings.CutterCore.delFlag(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.delFunction(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.deleteClass(self,cls:QString)",
    "CutterBindings.CutterCore.disableBreakpoint(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.disassemble(self,data:PySide2.QtCore.QByteArray)->QString",
    "CutterBindings.CutterCore.disassembleSingleInstruction(self,addr:unsigned long long)->QString",
    "CutterBindings.CutterCore.editBytes(self,addr:unsigned long long,inst:QString)",
    "CutterBindings.CutterCore.editBytesEndian(self,addr:unsigned long long,bytes:QString)",
    "CutterBindings.CutterCore.editInstruction(self,addr:unsigned long long,inst:QString,fillWithNops:bool=false)",
    "CutterBindings.CutterCore.enableBreakpoint(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.existsFileInfo(self)->bool",
    "CutterBindings.CutterCore.flagAt(self,addr:unsigned long long)->QString",
    "CutterBindings.CutterCore.getActiveDebugPlugin(self)->QString",
    "CutterBindings.CutterCore.getAllAnalysisClasses(self,sorted:bool)->QList[QString]",
    "CutterBindings.CutterCore.getAnalysisPluginNames(self)->QStringList",
    "CutterBindings.CutterCore.getArchBits(self)->int",
    "CutterBindings.CutterCore.getAsmPluginNames(self)->QStringList",
    "CutterBindings.CutterCore.getBBHighlighter(self)->CutterBindings.BasicBlockHighlighter",
    "CutterBindings.CutterCore.getBreakpointsAddresses(self)->QList[unsigned long long]",
    "CutterBindings.CutterCore.getBreakpointsInFunction(self,funcAddr:unsigned long long)->QList[unsigned long long]",
    "CutterBindings.CutterCore.getColorThemes(self)->QStringList",
    "CutterBindings.CutterCore.getCommentAt(self,addr:unsigned long long)->QString",
    "1:CutterBindings.CutterCore.getConfig(self,k:QString)->QString",
    "0:CutterBindings.CutterCore.getConfig(self,k:char*)->QString",
    "CutterBindings.CutterCore.getConfigDescription(self,k:char*)->QString",
    "CutterBindings.CutterCore.getConfigOptions(self,k:char*)->QStringList",
    R"CPP(CutterBindings.CutterCore.getConfigVariableSpaces(self,key:QString="")->QStringList)CPP",
    "1:CutterBindings.CutterCore.getConfigb(self,k:QString)->bool",
    "0:CutterBindings.CutterCore.getConfigb(self,k:char*)->bool",
    "1:CutterBindings.CutterCore.getConfigi(self,k:QString)->int",
    "0:CutterBindings.CutterCore.getConfigi(self,k:char*)->int",
    "1:CutterBindings.CutterCore.getConfigut64(self,k:QString)->unsigned long long",
    "0:CutterBindings.CutterCore.getConfigut64(self,k:char*)->unsigned long long",
    "CutterBindings.CutterCore.getCutterRCDefaultDirectory(self)->PySide2.QtCore.QDir",
    "CutterBindings.CutterCore.getDebugPlugins(self)->QStringList",
    "CutterBindings.CutterCore.getDisassemblyPreview(self,address:unsigned long long,num_of_lines:int)->QStringList",
    "CutterBindings.CutterCore.getFunctionEnd(self,addr:unsigned long long)->unsigned long long",
    "CutterBindings.CutterCore.getFunctionStart(self,addr:unsigned long long)->unsigned long long",
    "CutterBindings.CutterCore.getHexdumpPreview(self,offset:unsigned long long,size:int)->QString",
    "CutterBindings.CutterCore.getInstructionBytes(self,addr:unsigned long long)->QString",
    "CutterBindings.CutterCore.getInstructionOpcode(self,addr:unsigned long long)->QString",
    "CutterBindings.CutterCore.getLastFunctionInstruction(self,addr:unsigned long long)->unsigned long long",
    "CutterBindings.CutterCore.getMetaString(self,addr:unsigned long long)->QString",
    "1:CutterBindings.CutterCore.getOffset(self)->unsigned long long",
    "0:CutterBindings.CutterCore.getOffset(self)->unsigned long long",
    "CutterBindings.CutterCore.getOffsetJump(self,addr:unsigned long long)->unsigned long long",
    "CutterBindings.CutterCore.getProgramCounterValue(self)->unsigned long long",
    "CutterBindings.CutterCore.getRegisterName(self,registerRole:QString)->QString",
    "CutterBindings.CutterCore.getRegs(self)",
    "CutterBindings.CutterCore.getRizinVersionReadable(self,program:char*=nullptr)->QString",
    "CutterBindings.CutterCore.getSectionList(self)->QStringList",
    "CutterBindings.CutterCore.getSeekHistory(self)->QList[unsigned long long]",
    "CutterBindings.CutterCore.getString(self,addr:unsigned long long)->QString",
    "CutterBindings.CutterCore.getTheme(self)->QHash[QString, PySide2.QtGui.QColor]",
    "CutterBindings.CutterCore.getThemeKeys(self)->QStringList",
    "CutterBindings.CutterCore.getTypeAsC(self,name:QString)->QString",
    "CutterBindings.CutterCore.getVersionInformation(self)->QString",
    "CutterBindings.CutterCore.handleREvent(self,type:int,data:void)",
    "CutterBindings.CutterCore.hexStringToBytes(hex:QString)->PySide2.QtCore.QByteArray",
    "CutterBindings.CutterCore.initialize(self,loadPlugins:bool=true)",
    "CutterBindings.CutterCore.instance()->CutterBindings.CutterCore",
    "CutterBindings.CutterCore.ioRead(self,addr:unsigned long long,len:int)->PySide2.QtCore.QByteArray",
    "CutterBindings.CutterCore.isAddressMapped(self,addr:unsigned long long)->bool",
    "CutterBindings.CutterCore.isBreakpoint(self,breakpoints:QList[unsigned long long],addr:unsigned long long)->bool",
    "CutterBindings.CutterCore.isDebugTaskInProgress(self)->bool",
    "CutterBindings.CutterCore.isGraphEmpty(self)->bool",
    "CutterBindings.CutterCore.isIOCacheEnabled(self)->bool",
    "CutterBindings.CutterCore.isRedirectableDebugee(self)->bool",
    "CutterBindings.CutterCore.isWriteModeEnabled(self)->bool",
    "CutterBindings.CutterCore.itoa(self,num:unsigned long long,rdx:int=16)->QString",
    "CutterBindings.CutterCore.jmpReverse(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.listFlagsAsStringAt(self,addr:unsigned long long)->QString",
    "CutterBindings.CutterCore.loadCutterRC(self)",
    "CutterBindings.CutterCore.loadDefaultCutterRC(self)",
    "CutterBindings.CutterCore.loadFile(self,path:QString,baddr:unsigned long long=0LL,mapaddr:unsigned long long=0LL,perms:int=RZ_PERM_R,va:int=0,loadbin:bool=false,forceBinPlugin:QString=QString())->bool",
    "CutterBindings.CutterCore.loadPDB(self,file:QString)",
    "CutterBindings.CutterCore.loadScript(self,scriptname:QString)",
    "CutterBindings.CutterCore.mapFile(self,path:QString,mapaddr:unsigned long long)->bool",
    "CutterBindings.CutterCore.math(self,expr:QString)->unsigned long long",
    "CutterBindings.CutterCore.message(self,msg:QString,debug:bool=false)",
    "CutterBindings.CutterCore.nearestFlag(self,offset:unsigned long long,flagOffsetOut:unsigned long long*)->QString",
    "CutterBindings.CutterCore.nextOpAddr(self,startAddr:unsigned long long,count:int)->unsigned long long",
    "CutterBindings.CutterCore.nopInstruction(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.num(self,expr:QString)->unsigned long long",
    "CutterBindings.CutterCore.prevOpAddr(self,startAddr:unsigned long long,count:int)->unsigned long long",
    "CutterBindings.CutterCore.removeString(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.renameAnalysisMethod(self,className:QString,oldMethodName:QString,newMethodName:QString)",
    "CutterBindings.CutterCore.renameClass(self,oldName:QString,newName:QString)",
    "CutterBindings.CutterCore.renameFlag(self,old_name:QString,new_name:QString)",
    "CutterBindings.CutterCore.renameFunction(self,offset:unsigned long long,newName:QString)",
    "CutterBindings.CutterCore.renameFunctionVariable(self,newName:QString,oldName:QString,functionAddress:unsigned long long)",
    "CutterBindings.CutterCore.resetWriteCache(self)",
    "CutterBindings.CutterCore.sanitizeStringForCommand(s:QString)->QString",
    "CutterBindings.CutterCore.sdbGet(self,path:QString,key:QString)->QString",
    "CutterBindings.CutterCore.sdbList(self,path:QString)->QList[QString]",
    "CutterBindings.CutterCore.sdbListKeys(self,path:QString)->QList[QString]",
    "CutterBindings.CutterCore.sdbSet(self,path:QString,key:QString,val:QString)->bool",
    "1:CutterBindings.CutterCore.seek(self,thing:QString)",
    "0:CutterBindings.CutterCore.seek(self,offset:unsigned long long)",
    "1:CutterBindings.CutterCore.seekAndShow(self,thing:QString)",
    "0:CutterBindings.CutterCore.seekAndShow(self,offset:unsigned long long)",
    "CutterBindings.CutterCore.seekNext(self)",
    "CutterBindings.CutterCore.seekPrev(self)",
    "1:CutterBindings.CutterCore.seekSilent(self,thing:QString)",
    "0:CutterBindings.CutterCore.seekSilent(self,offset:unsigned long long)",
    "CutterBindings.CutterCore.setAsString(self,addr:unsigned long long,size:int=0)",
    "CutterBindings.CutterCore.setBreakpointTrace(self,index:int,enabled:bool)",
    "CutterBindings.CutterCore.setCPU(self,arch:QString,cpu:QString,bits:int)",
    "CutterBindings.CutterCore.setColor(self,key:QString,color:QString)->bool",
    "CutterBindings.CutterCore.setComment(self,addr:unsigned long long,cmt:QString)",
    "9:CutterBindings.CutterCore.setConfig(self,k:QString,v:bool)",
    "8:CutterBindings.CutterCore.setConfig(self,k:QString,v:QString)",
    "7:CutterBindings.CutterCore.setConfig(self,k:QString,v:QVariant)",
    "6:CutterBindings.CutterCore.setConfig(self,k:QString,v:char*)",
    "5:CutterBindings.CutterCore.setConfig(self,k:QString,v:int)",
    "4:CutterBindings.CutterCore.setConfig(self,k:char*,v:bool)",
    "3:CutterBindings.CutterCore.setConfig(self,k:char*,v:QString)",
    "2:CutterBindings.CutterCore.setConfig(self,k:char*,v:QVariant)",
    "1:CutterBindings.CutterCore.setConfig(self,k:char*,v:char*)",
    "0:CutterBindings.CutterCore.setConfig(self,k:char*,v:int)",
    "CutterBindings.CutterCore.setCurrentBits(self,bits:int,offset:unsigned long long=RVA_INVALID)",
    "CutterBindings.CutterCore.setCurrentDebugProcess(self,pid:int)",
    "CutterBindings.CutterCore.setCurrentDebugThread(self,tid:int)",
    "CutterBindings.CutterCore.setDebugPlugin(self,plugin:QString)",
    "CutterBindings.CutterCore.setEndianness(self,big:bool)",
    "CutterBindings.CutterCore.setGraphEmpty(self,empty:bool)",
    "CutterBindings.CutterCore.setIOCache(self,enabled:bool)",
    "CutterBindings.CutterCore.setImmediateBase(self,rzBaseName:QString,offset:unsigned long long=RVA_INVALID)",
    "CutterBindings.CutterCore.setRegister(self,regName:QString,regValue:QString)",
    "CutterBindings.CutterCore.setSettings(self)",
    "CutterBindings.CutterCore.setToCode(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.setToData(self,addr:unsigned long long,size:int,repeat:int=1)",
    "CutterBindings.CutterCore.setWriteMode(self,enabled:bool)",
    "CutterBindings.CutterCore.showMemoryWidget(self)",
    "CutterBindings.CutterCore.sizeofDataMeta(self,addr:unsigned long long)->int",
    "CutterBindings.CutterCore.startDebug(self)",
    "CutterBindings.CutterCore.startEmulation(self)",
    "CutterBindings.CutterCore.startTraceSession(self)",
    "CutterBindings.CutterCore.stepBackDebug(self)",
    "CutterBindings.CutterCore.stepDebug(self)",
    "CutterBindings.CutterCore.stepOutDebug(self)",
    "CutterBindings.CutterCore.stepOverDebug(self)",
    "CutterBindings.CutterCore.stopDebug(self)",
    "CutterBindings.CutterCore.stopTraceSession(self)",
    "CutterBindings.CutterCore.suspendDebug(self)",
    "CutterBindings.CutterCore.syncAndSeekProgramCounter(self)",
    "CutterBindings.CutterCore.toggleBreakpoint(self,addr:unsigned long long)",
    "CutterBindings.CutterCore.triggerAsmOptionsChanged(self)",
    "CutterBindings.CutterCore.triggerFlagsChanged(self)",
    "CutterBindings.CutterCore.triggerFunctionRenamed(self,offset:unsigned long long,newName:QString)",
    "CutterBindings.CutterCore.triggerGraphOptionsChanged(self)",
    "CutterBindings.CutterCore.triggerRefreshAll(self)",
    "CutterBindings.CutterCore.triggerVarsChanged(self)",
    "CutterBindings.CutterCore.tryFile(self,path:QString,rw:bool)->bool",
    "CutterBindings.CutterCore.updateSeek(self)",
    nullptr}; // Sentinel

void init_CutterCore(PyObject *module)
{
    _Sbk_CutterCore_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "CutterCore",
        "CutterCore*",
        &Sbk_CutterCore_spec,
        &Shiboken::callCppDestructor< ::CutterCore >,
        reinterpret_cast<SbkObjectType *>(SbkPySide2_QtCoreTypes[SBK_QOBJECT_IDX]),
        0,
        0    );
    
    auto pyType = reinterpret_cast<PyTypeObject *>(_Sbk_CutterCore_Type);
    InitSignatureStrings(pyType, CutterCore_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_CutterCore_Type), Sbk_CutterCore_PropertyStrings);
    SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX]
        = reinterpret_cast<PyTypeObject *>(Sbk_CutterCore_TypeF());

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_CutterCore_TypeF(),
        CutterCore_PythonToCpp_CutterCore_PTR,
        is_CutterCore_PythonToCpp_CutterCore_PTR_Convertible,
        CutterCore_PTR_CppToPython_CutterCore);

    Shiboken::Conversions::registerConverterName(converter, "CutterCore");
    Shiboken::Conversions::registerConverterName(converter, "CutterCore*");
    Shiboken::Conversions::registerConverterName(converter, "CutterCore&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::CutterCore).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(::CutterCoreWrapper).name());


    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(Sbk_CutterCore_TypeF(), &Sbk_CutterCore_typeDiscovery);

    PySide::Signal::registerSignals(Sbk_CutterCore_TypeF(), &::CutterCore::staticMetaObject);
    Shiboken::ObjectType::setSubTypeInitHook(Sbk_CutterCore_TypeF(), &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(Sbk_CutterCore_TypeF(), &::CutterCore::staticMetaObject, sizeof(CutterCoreWrapper));
}
